-----------------------------------------------------------------------------
-- |
-- Module      :  Camila.Combinadores
-- Copyright   :  jbb?
-- License     :  ?
--
-- Maintainer  :  ?
-- Stability   :  experimental
-- Portability :  experimental
--
-- Useful for defining read instances.
-- 
-----------------------------------------------------------------------------

module Camila.Combinadores where

depois :: (ReadS a) -> (ReadS b) -> ReadS (a,b)
depois _ _ [] = []
depois r1 r2 input = [((x,y),i2) | (x,i1) <- r1 input , (y,i2) <- r2 i1]

readSeq :: (ReadS a) -> ReadS [a]
readSeq r input
  = case (r input) of
      [] -> [([],input)]
      l  -> do { -- lists
                 (x,l1)  <- l ;
                 (xs,l3) <- readSeq r l1 ;
                 return ((x:xs), l3)
               }

readSeqSep :: String -> (ReadS a) -> ReadS [a]
readSeqSep sep r input
  = case (r input) of
      [] -> [([],input)]
      l  -> do { -- lists
                 (x,l1)  <- l ;
                 case (readConst sep l1) of
                 [] -> return ([x],l1)
                 l2 -> do {
                            (_,l3)  <- l2 ;
                            (xs,l4) <- readSeqSep sep r l3 ;
                             return ((x:xs), l4)
                          }
               }

ou :: (ReadS a) -> (ReadS a) -> ReadS a
ou r1 r2 input = (r1 input) ++ (r2 input)

senao :: (ReadS a) -> (ReadS a) -> ReadS a
senao r1 r2 input = case (r1 input) of
                     [] -> r2 input
                     l  -> l


readConst :: String -> ReadS String
readConst c = (filter ((== c).fst)) . lex

readConsts :: [(String,a)] -> ReadS a
readConsts l = (match l) . lex
        where match l [] = []
              match l ((s,i):ls) = case (lookup s l) of
                                   Nothing -> match l ls
                                   Just a  -> (a,s):(match l ls)

pcurvos = parentesis '(' ')'
prectos = parentesis '[' ']'
chavetas = parentesis '{' '}'

parentesis :: Char -> Char -> (ReadS a) -> ReadS a
parentesis _ _ _ [] = []
parentesis ap pa r input 
  = do 
      ((_,(x,_)),c) <- ((readConst [ap]) `depois` 
                        (r `depois` (readConst [pa]))) input
      return (x,c)

