-----------------------------------------------------------------------------
-- |
-- Module      :  Camila.DTInvariants
-- Copyright   :  (c) Alexandra Mendes, Joo Ferreira
-- License     :  GPL
--
-- Maintainer  :  Joo Ferreira, Alexandra Mendes
-- Stability   :  experimental
-- Portability :  experimental
--
-- Datatype invariants
-- 
-----------------------------------------------------------------------------


module Camila.DTInvariants (module Camila.DTInvariants) where

import Camila.Error

class CData a where
    inv :: a -> Bool
    inv a = True
    inv' :: a -> Error a
    inv' a = if (inv a) then Ok a else Err "Invariant violation"

instance (CData a, CData b) => CData (a,b) where
    inv(a,b) = (inv a) && (inv b)

instance (CData a, CData b) => CData (Either a b) where
    inv (Left a) = inv a
    inv (Right b) = inv b
