-----------------------------------------------------------------------------
-- |
-- Module      :  Camila.Error
-- Copyright   :  (c) Alexandra Mendes, Joo Ferreira
-- License     :  GPL
--
-- Maintainer  :  Joo Ferreira, Alexandra Mendes
-- Stability   :  experimental
-- Portability :  experimental
--
-- Module that defines Error Monad
-- 
-----------------------------------------------------------------------------


module Camila.Error (
   module Camila.Error
) where


data Error a = Err String | Ok a deriving (Show, Eq)

instance Monad Error where
    return b = Ok b
    (Err e) >>=  f =  Err e
    (Ok  a) >>=  f = f a

