-----------------------------------------------------------------------------
-- |
-- Module      :  Data.FiniteMapExtrasHUnit
-- Copyright   :  (c) Joo Ferreira, Alexandra Mendes
-- License     :  GPL
-- 
-- Maintainer  :  Joo Ferreira, Alexandra Mendes
-- Stability   :  experimental
-- Portability :  experimental
--
-- Tests for the implementation of Camila.Prelude.
--
-----------------------------------------------------------------------------

module Data.FiniteMapExtrasHUnit where

import Camila.Prelude
import HUnit

-----------------------------------------------------------------------------

main
  = runTestTT . TestList $ testList
  
labeledTest l t
  = TestLabel l (TestCase t)

testList
  = [ labeledTest "testEmpty" (
        do let fm = emptyFM :: FiniteMap Int Int 
           assertEqual "Domain should be empty" emptySet (domFM fm)
           assertEqual "Range should be empty" emptySet (rngFM fm)
      ),
      labeledTest "testSingleton" (
        do let fm = listToFM [(1,2)] 
           assertEqual "Domain" (mkSet [1]) (domFM fm)
           assertEqual "Range" (mkSet [2]) (rngFM fm)
      )]
-----------------------------------------------------------------------------

