-----------------------------------------------------------------------------
-- |
-- Copyright   :  (c) Joost Visser 2004
-- License     :  LGPL
-- 
-- Maintainer  :  joost.visser@di.uminho.pt
-- Stability   :  experimental
-- Portability :  portable
--
-- An implementation of relations as sets of pairs.
--
-----------------------------------------------------------------------------

module Data.Relation.FormalConceptAnalysisQuickCheck where

import Data.Relation.FormalConceptAnalysis
import Data.Set
import Data.Relation.SetOfPairs
import Data.Relation.SetOfPairsQuickCheck
import Debug.QuickCheck

prop_lattice cxt
  = classify (cardinality cxt /= 0) "non-empty" $
    and (map (\c -> c `isConceptOf` cxt) (setToList (ent l))) &&
    and (map (uncurry conceptGT) (setToList l))
    where
      l = lattice cxt
      types = (cxt::Context Int Int)

prop_latticeInv cxt
  = classify (cardinality cxt /= 0) "non-empty" $
    lattice cxt == dualConceptLattice (lattice (inv cxt))
    where
      types = (cxt::Context Int Int)

-----------------------------------------------------------------------------
