-----------------------------------------------------------------------------
-- |
-- Module      :  Data.Relation.MapFromPairsQuickCheck
-- Copyright   :  (c) Joost Visser 2004
-- License     :  LGPL
-- 
-- Maintainer  :  joost.visser@di.uminho.pt
-- Stability   :  experimental
-- Portability :  portable
--
-- Properties of the implementation of labeled relations as maps from pairs.
--
-----------------------------------------------------------------------------

module Data.Relation.MapFromPairsQuickCheck where

import Data.Set
import Data.Relation.SetOfPairs
import Data.Relation.MapFromPairs
import Data.Relation.SetOfPairsQuickCheck () -- only instances
import Debug.QuickCheck

-----------------------------------------------------------------------------

instance (Ord a, Arbitrary a, Arbitrary b)
      => Arbitrary (FiniteMap a b) where
  arbitrary = do xs <- arbitrary
                 return (listToFM xs)
                 
-----------------------------------------------------------------------------

prop_TransCloseReach r
  = classify (cardinality r /= 0) "non-empty" $
    rel id (reach (lrel True r)) == transClose r
    where
      types = (r::Rel Int Int)

-----------------------------------------------------------------------------

