


\begin{code}
module Language.ContextFree.Examples.Html_Tables where

import Language.ContextFree.Cfg
import Language.ContextFree.LR_0

cfg_html_table =  Cfg [T "<TABLE>",T "<TR>",T "<TD>",T "</TABLE>",T "</TR>",T "</TD>",T "[a-zA-Z]+"]
                      [NT "Tabela",NT "Linhas",NT "Linha",NT "Colunas",NT "Coluna",NT "Elem"]
                      (NT "Tabela")
                      [("T", NT  "Tabela"  |-> [T "<TABLE>",NT "Linhas",T "</TABLE>"])
                      ,("L0",NT  "Linhas"  |-> [])
                      ,("Ls",NT  "Linhas"  |-> [NT "Linha",NT "Linhas"])
                      ,("L", NT  "Linha"   |-> [T "<TR>",NT "Colunas",T "</TR>"])
                      ,("C0",NT  "Colunas" |-> [])
                      ,("Cs",NT  "Colunas" |-> [NT "Coluna",NT "Colunas"])
                      ,("C", NT  "Coluna"  |-> [T "<TD>", NT "Colunas",T "</TD>"])
                      ,("E0",NT  "Elem"    |-> [T "[a-zA-Z]+"])
                      ,("ET",NT  "Elem"    |-> [NT "Tabela"])
                      ]
\end{code}


\begin{verbatim}
Main> first_N cfg_html_table "Linhas"
["<TR>"]
Main> follow cfg_html_table "Linhas"
["</TABLE>"]
Main> follow cfg_html_table "Colunas"
["</TR>","</TD>"]
Main> lookaheads_nt cfg_html_table "Linhas"
[["</TABLE>"],["<TR>"]]
Main> lookaheads_nt cfg_html_table "Colunas"
[["</TR>","</TD>"],["<TD>"]]
Main> ll_1 cfg_html_table
True
\end{verbatim}




\begin{code}
cfg_html_table2 =  Cfg [T "<TABLE>",T "<TR>",T "<TD>",T "</TABLE>",T "</TR>",T "</TD>",T "[a-zA-Z]+"]
                       [NT "Tabela",NT "Linhas",NT "Linha",NT "Colunas",NT "Coluna",NT "Elem"]
                       (NT "Tabela")
                       [("T", NT "Tabela"  |-> [T "<TABLE>", NT "Linhas",T "</TABLE>"])
                       ,("L0",NT "Linhas"  |-> [])
                       ,("Ls",NT "Linhas"  |-> [NT "Linha",NT "Linhas"])
                       ,("L", NT "Linha"   |-> [T "<TR>", NT "Colunas",T "</TR>"])
                       ,("C0",NT "Colunas" |-> [])
                       ,("Cs",NT "Colunas" |-> [NT "Coluna",NT "Colunas"])
                       ,("C0",NT "Coluna"  |-> [T "<TD>",T "[a-zA-Z]+",T "</TD>"])
                       ,("CT",NT "Coluna"  |-> [T "<TD>",NT "Tabela",T "</TD>"])
                       ]
\end{code}


\begin{code}
table2gv = saveLR_0Dfa cfg_html_table2 
\end{code}
