-----------------------------------------------------------------------------
-- |
-- Copyright   :  (c) Universidade do Minho, 2004
-- License     :  LGPL
-- 
-- Maintainer  :  Joo Saraiva - jas@di.uminho.pt
-- Stability   :  experimental
-- Portability :  portable
--
-- Representation of (Parsing) Tables 
--
-----------------------------------------------------------------------------

module 	Language.ContextFree.Tables
	( Table
--        , lookup 
	, coercePTable
	, ptable2Matrix
	, ptable2TableString 
        , ppPTable
        ) where

------------------------------------------------------------------------------

import PrettyPrint.Tables.Combinators

------------------------------------------------------------------------------
-- | The type of the (parsing) table

type Table r c = [(r,[c])]


{--
lookup
prettyPrint
--}

coercePTable :: (a -> b) -> (c -> d) -> Table a c -> Table b d
coercePTable r2Str c2Str []         = []
coercePTable r2Str c2Str ((r,cs):t) = (r2Str r,map c2Str cs) : coercePTable r2Str c2Str t

ptable2Matrix :: (a -> b) -> (c -> b) -> Table a c -> [[b]]
ptable2Matrix r2Str c2Str []         = []
ptable2Matrix r2Str c2Str ((r,cs):t) = (r2Str r : (map c2Str cs)) : ptable2Matrix r2Str c2Str t


ptable2TableString :: (Show r, Show c) => Table r c -> Table String String
ptable2TableString = coercePTable show show

ppPTable :: (a -> String) -> (b -> String) -> Table a b -> String
ppPTable ppR ppC t = asciiT' $ matrix2table $ ptable2Matrix ppR ppC t




