module Language.Dot.IO where

import Language.Dot.Syntax
import Language.Dot.SyntaxATermConvertibleInstances
import Language.Dot.SyntaxTermInstances
import Language.Dot.Pretty
import ChaseImports (findFile) {- from Strafunski -}
import SGLR
import GPP

readDotFile :: [FilePath] -> FilePath -> IO Graph
readDotFile searchPath relativeName
  = do tableName <- findFile searchPath "dot" ["tbl"]  
       fileName <- findFile searchPath relativeName ["dot"]
       sglr tableName fileName "Graph"

parseAndPrint :: [FilePath] -> FilePath -> FilePath -> IO ()
parseAndPrint searchPath relativeNameIn relativeNameOut
  = do (graph::Graph) <- readDotFile searchPath relativeNameIn
       writeFile relativeNameOut (pp graph)
    where
      pp = renderFix uppSyntax