module Language.Dot.Pretty where
import Language.Dot.Syntax
import Language.Dot.SyntaxTermInstances
import Text.PrettyPrint.HughesPJ
import GPP
import StrategyLib
 
instance PP Graph where
	pp gpp (Dot_graph _0 _1 _2 _4)
	  = fsep
	      [gppMaybe gpp _0, gppEither gpp _1, gpp _2, gpp "{", gpp _4,
	       gpp "}"]
 
instance PP Strict where
	pp gpp (Strict) = fsep [gpp "strict"]
 
instance PP Stmt_List where
	pp gpp (Stmt_opt_s _0) = fsep [gppList gpp _0]
 
instance PP Stmt where
	pp gpp (Attr_Stmt _0) = fsep [gpp _0]
	pp gpp (Node_Stmt _0) = fsep [gpp _0]
	pp gpp (Edge_Stmt _0) = fsep [gpp _0]
	pp gpp (SubGraph _0) = fsep [gpp _0]
	pp gpp (Alias _0 _2) = fsep [gpp _0, gpp "=", gpp _2]
 
instance PP Attr_Stmt where
	pp gpp (Graph _2) = fsep [gpp "graph", gpp "[", gpp _2, gpp "]"]
	pp gpp (Node _2) = fsep [gpp "node", gpp "[", gpp _2, gpp "]"]
	pp gpp (Edge _2) = fsep [gpp "edge", gpp "[", gpp _2, gpp "]"]
 
instance PP Attr where
	pp gpp (Attr_id _0 _2) = fsep [gpp _0, gpp "=", gpp _2]
	pp gpp (Attr_num_con _0 _2) = fsep [gpp _0, gpp "=", gpp _2]
 
instance PP Attr_List where
	pp gpp (Attr_s _0) = fsep [gppListSep gpp "," _0]
 
instance PP Node_Stmt where
	pp gpp (Node_stmt _0 _1) = fsep [gpp _0, gppMaybe gpp _1]
 
instance PP Node_Id where
	pp gpp (Id _0) = fsep [gpp _0]
	pp gpp (Id_Id_or_Num_Con _0 _2)
	  = fsep [gpp _0, gpp ":", gppEither gpp _2]
 
instance PP Attrs where
	pp gpp (Attr_List _1) = fsep [gpp "[", gpp _1, gpp "]"]
 
instance PP Edge_Stmt where
	pp gpp (Edge_stmt _0 _1 _2 _3)
	  = fsep [gppEither gpp _0, gpp _1, gpp _2, gppMaybe gpp _3]
 
instance PP MoreEdges where
	pp gpp (MoreEdges0 _0) = fsep [gppEither gpp _0]
	pp gpp (MoreEdges1 _0 _1 _2)
	  = fsep [gppEither gpp _0, gpp _1, gpp _2]
 
instance PP SubGraph where
	pp gpp (Sub_graph _1 _2)
	  = fsep [gpp "subgraph", gpp _1, gppMaybe gpp _2]
 
instance PP EdgeOp where
	pp gpp (Arrow) = fsep [gpp "_>"]
	pp gpp (Line) = fsep [gpp "__"]
 
uppSyntax :: UPP
uppSyntax gpp
  = (constTU empty) `adhocQ` (pp gpp :: MonoPP String) `adhocQ`
      (pp gpp :: MonoPP Graph)
      `adhocQ` (pp gpp :: MonoPP Strict)
      `adhocQ` (pp gpp :: MonoPP Stmt_List)
      `adhocQ` (pp gpp :: MonoPP Stmt)
      `adhocQ` (pp gpp :: MonoPP Attr_Stmt)
      `adhocQ` (pp gpp :: MonoPP Attr)
      `adhocQ` (pp gpp :: MonoPP Attr_List)
      `adhocQ` (pp gpp :: MonoPP Node_Stmt)
      `adhocQ` (pp gpp :: MonoPP Node_Id)
      `adhocQ` (pp gpp :: MonoPP Attrs)
      `adhocQ` (pp gpp :: MonoPP Edge_Stmt)
      `adhocQ` (pp gpp :: MonoPP MoreEdges)
      `adhocQ` (pp gpp :: MonoPP SubGraph)
      `adhocQ` (pp gpp :: MonoPP EdgeOp)