module Language.Dot.Syntax where
 
data Graph = Dot_graph (Maybe Strict) (Either Graph DiGraph) Id
		       Stmt_List
	   | Undigraph
 
data DiGraph = Digraph
 
data Strict = Strict
 
data Stmt_List = Stmt_opt_s [(Stmt, Maybe ())]
 
data Stmt = Attr_Stmt Attr_Stmt
	  | Node_Stmt Node_Stmt
	  | Edge_Stmt Edge_Stmt
	  | SubGraph SubGraph
	  | Alias Id Id
 
data Attr_Stmt = Graph Attr_List
	       | Node Attr_List
	       | Edge Attr_List
 
data Attr = Attr_id Id Id
	  | Attr_num_con Id Num_Con
 
data Attr_List = Attr_s [Attr]
 
data Node_Stmt = Node_stmt Node_Id (Maybe Attrs)
 
data Node_Id = Id Id
	     | Id_Id_or_Num_Con Id (Either Id Num_Con)
 
data Attrs = Attr_List Attr_List
 
data Edge_Stmt = Edge_stmt (Either Node_Id SubGraph) EdgeOp
			   MoreEdges (Maybe Attrs)
 
data MoreEdges = MoreEdges0 (Either Node_Id SubGraph)
	       | MoreEdges1 (Either Node_Id SubGraph) EdgeOp MoreEdges
 
data SubGraph = Sub_graph Id (Maybe (Stmt_List))
 
data EdgeOp = Arrow
	    | Line
 
type EscChar = String
 
type L_Char = String
 
type QuotedLiteral = String
 
type Num_Con = String
 
type UnquotedId = String
 
type Id = String