module Language.Gnumeric.Syntax where
import Language.Gnumeric.Formula
import Text.XML.HaXml.Xml2Haskell
import Language.Gnumeric.Xml2HaskellReadInstances
import Text.XML.HaXml.OneOfN


{-Type decls-}

data Gmr'Cells = Gmr'Cells Gmr'Cells_Attrs [Gmr'Cell]
	       deriving (Eq,Show,Read)
data Gmr'Cells_Attrs = Gmr'Cells_Attrs
    { gmr'CellsXmlns :: (Defaultable String)
    } deriving (Eq,Show,Read)
data Gmr'Cell = Gmr'Cell Gmr'Cell_Attrs String
	      deriving (Eq,Show,Read)
data Gmr'Cell_Attrs = Gmr'Cell_Attrs
    { gmr'CellXmlns :: (Defaultable String)
    , gmr'CellCol :: String
    , gmr'CellRow :: String
    , gmr'CellExprID :: (Maybe String)
    , gmr'CellValueType :: (Maybe String)
    , gmr'CellValueFormat :: (Maybe String)
    , gmr'CellCols :: (Maybe String)
    , gmr'CellRows :: (Maybe String)
    , gmr'CellAst :: (Maybe Formula)
    } deriving (Eq,Show,Read)


{-Instance decls-}

instance XmlContent Gmr'Cells where
    fromElem (CElem (Elem "gmr:Cells" as c0):rest) =
	(\(a,ca)->
	   (Just (Gmr'Cells (fromAttrs as) a), rest))
	(many fromElem c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'Cells as a) =
	[CElem (Elem "gmr:Cells" (toAttrs as) (concatMap toElem a))]
instance XmlAttributes Gmr'Cells_Attrs where
    fromAttrs as =
	Gmr'Cells_Attrs
	  { gmr'CellsXmlns = defaultA fromAttrToStr "http://www.gnumeric.org/v10.dtd" "xmlns" as
	  }
    toAttrs v = catMaybes 
	[ defaultToAttr toAttrFrStr "xmlns" (gmr'CellsXmlns v)
	]
instance XmlContent Gmr'Cell where
    fromElem (CElem (Elem "gmr:Cell" as c0):rest) =
	(\(a,ca)->
	   (Just (Gmr'Cell (fromAttrs as) a), rest))
	(definite fromText "text" "gmr:Cell" c0)
    fromElem (CMisc _:rest) = fromElem rest
    fromElem rest = (Nothing, rest)
    toElem (Gmr'Cell as a) =
	[CElem (Elem "gmr:Cell" (toAttrs as) (toText a))]
instance XmlAttributes Gmr'Cell_Attrs where
    fromAttrs as =
	Gmr'Cell_Attrs
	  { gmr'CellXmlns = defaultA fromAttrToStr "http://www.gnumeric.org/v10.dtd" "xmlns" as
	  , gmr'CellCol = definiteA fromAttrToStr "gmr:Cell" "Col" as
	  , gmr'CellRow = definiteA fromAttrToStr "gmr:Cell" "Row" as
	  , gmr'CellExprID = possibleA fromAttrToStr "ExprID" as
	  , gmr'CellValueType = possibleA fromAttrToStr "ValueType" as
	  , gmr'CellValueFormat = possibleA fromAttrToStr "ValueFormat" as
	  , gmr'CellCols = possibleA fromAttrToStr "Cols" as
	  , gmr'CellRows = possibleA fromAttrToStr "Rows" as
	  , gmr'CellAst = Nothing
	  }
    toAttrs v = catMaybes 
	[ defaultToAttr toAttrFrStr "xmlns" (gmr'CellXmlns v)
	, toAttrFrStr "Col" (gmr'CellCol v)
	, toAttrFrStr "Row" (gmr'CellRow v)
	, maybeToAttr toAttrFrStr "ExprID" (gmr'CellExprID v)
	, maybeToAttr toAttrFrStr "ValueType" (gmr'CellValueType v)
	, maybeToAttr toAttrFrStr "ValueFormat" (gmr'CellValueFormat v)
	, maybeToAttr toAttrFrStr "Cols" (gmr'CellCols v)
	, maybeToAttr toAttrFrStr "Rows" (gmr'CellRows v)
	-- maybeToAttr toAttrFrStr "ast" (gmr'CellAst v)
	]


{-Done-}
