-----------------------------------------------------------------------------
-- |
-- Copyright   :  (c) Joost Visser 2004
-- License     :  LGPL
-- 
-- Maintainer  :  joost.visser@di.uminho.pt
-- Stability   :  experimental
-- Portability :  portable
--
-- This module defines some additional types for the Haskell
-- syntax which are useful in analysis and transformation functions.
--
-----------------------------------------------------------------------------

module Language.Haskell.ModuleCollection where

import Language.Haskell.Syntax (HsModule)

-- | A type synonym for Strings used as module names.
type ModuleName = String

-- | A type to represent a Haskell module. It is a triple of
--   the name of the module, its imports, and its AST.
type ModuleEntry = (ModuleName,[ModuleName],HsModule)

-- | A type to represent a collection of Haskell modules.
type ModuleCollection = [ModuleEntry]

-----------------------------------------------------------------------------
