-----------------------------------------------------------------------------
-- |
-- Copyright   :  (c) Joost Visser 2004
-- License     :  LGPL
-- 
-- Maintainer  :  joost.visser@di.uminho.pt
-- Stability   :  experimental
-- Portability :  portable
--
-- This module defines some additional functions on the Haskell
-- syntax which are useful in analysis and transformation functions.
--
-----------------------------------------------------------------------------

module Language.Haskell.SyntaxAccessors where

-----------------------------------------------------------------------------

import Language.Haskell.Syntax
import Language.Haskell.SyntaxTermInstances
import Language.Haskell.ModuleCollection

import StrategyLib
import Control.Monad.Identity

-----------------------------------------------------------------------------

-- | Extraction of imports
getImports :: HsModule -> [ModuleName]
getImports m
 = runIdentity (applyTU (full_tdTU worker) m)
   where
     worker :: TU [String] Identity
     worker =  adhocTU (constTU []) (\i -> return [getName i])

     getName :: HsImportDecl -> String
     getName (HsImportDecl _ (Module mid) _ _ _) = mid

-- | Extraction of module name
getModuleName :: HsModule -> String
getModuleName (HsModule _ (Module n) _ _ _)
  = n

-----------------------------------------------------------------------------
