-------------------------------------------------------------------------------
--
-- | 
-- Module      :  Language.VDM_SL.Syntax
-- Copyright   :  (c) Tiago Alves, Paulo Silva, 2004
-- License     :  LGPL
-- 
-- Maintainer  :  joost.visser@di.uminho.pt
-- Stability   :  experimental
-- Portability :  portable
--
-- Functions for easy access to the VSM-SL abstract syntax.
--
-------------------------------------------------------------------------------

module Language.VDM_SL.FuncLib where

import Language.VDM_SL.Syntax

-- | Test whether a given type is a composed type or not.
isComposed :: Type -> Bool
isComposed (SET_OF _ ) = True
isComposed (SEQ0_OF CHAR) = False
isComposed (SEQ0_OF _ ) = True
isComposed (SEQ1_OF CHAR) = False
isComposed (SEQ1_OF _ ) = True
isComposed (MAP_TYPE _ _ ) = True
isComposed (INMAP_TYPE _ _ ) = True
isComposed _ = False

-- | Get the value of an identifier as String.
getIdentifier :: Name -> String
getIdentifier (IDENTIFIER x) = x
getIdentifier (MK_ID x) = x
getIdentifier (IS_ID x) = x


-- | Function that merges the identifiers names.
mergeName :: Name -> Name -> Name
mergeName name1 name2 =
   let str1 = getIdentifier name1
       str2 = getIdentifier name2
   in IDENTIFIER (str1 ++ str2)

-------------------------------------------------------------------------------

