-------------------------------------------------------------------------------
--
-- | 
-- Module      :  Language.VDM_SL.HLStratLib
-- Copyright   :  (c) Tiago Alves, Paulo Silva, 2004
-- License     :  LGPL
-- 
-- Maintainer  :  joost.visser@di.uminho.pt
-- Stability   :  experimental
-- Portability :  portable
--
-- Auxiliary strategies.
--
-------------------------------------------------------------------------------
module Language.VDM_SL.HLStratLib where

import StrategyLib
import Control.Monad
import Control.Monad.Identity

-- Generic Strategies

-- |
stratTP :: (Monad m, Term t, Term r) => (t -> t) -> r -> m r
stratTP ap = applyTP $ full_tdTP $ adhocTP idTP ( return . ap )

-- |
stratTU :: (Monad m, Term t, Term r) => (t -> [a]) -> r -> m [a]
stratTU ap = applyTU $ full_tdTU $ adhocTU ( constTU [] ) ( return . ap )

-- |
strat_allTU :: (Monad m, Term t, Term r) => (t -> m [a] ) -> r -> m [a]
strat_allTU ap = applyTU $ allTU (++) [] (adhocTU (constTU []) ap)

-- | Strafunski collect
collectWith :: (Term t, Term r) => (t -> a) -> r -> [a]
collectWith f = runIdentity . (applyTU $ full_tdTU $ step)
   where step = constTU [] `adhocTU` (return . (\x -> [f x]))
