-------------------------------------------------------------------------------
--
-- | 
-- Module      :  Language.VDM_SL.SyntaxTermInstances
-- Copyright   :  (c) Tiago Alves, Paulo Silva, 2004
-- License     :  LGPL
-- 
-- Maintainer  :  joost.visser@di.uminho.pt
-- Stability   :  experimental
-- Portability :  portable
--
-- This module contains the instances definitions for Term and Typeable
-- for the VDM-SL abstract syntax of "Language.VDM_SL.Syntax". These instances
-- were generated with DrIFT.
--
-------------------------------------------------------------------------------

module Language.VDM_SL.SyntaxTermInstances where
import Language.VDM_SL.Syntax
import TermRep
{- Generated by DrIFT (Automatic class derivations for Haskell) -}
{-# LINE 1 "Syntax.hs" #-}
{-* Generated by DrIFT : Look, but Don't Touch. *-}
instance Term Document where
    explode (x::Document) = TermRep (toDyn x, f x, g x) where
	f (DEF_BLOCK_S aa) = [explode aa]
	f (DEF_BLOCK_L ab ac) = [explode ab,explode ac]
	g (DEF_BLOCK_S _) xs = case TermRep.fArgs xs of [aa] -> toDyn ((DEF_BLOCK_S (TermRep.fDyn aa))::Document) ; _ -> error "Term explosion error."
	g (DEF_BLOCK_L _ _) xs = case TermRep.fArgs xs of [ab,ac] -> toDyn ((DEF_BLOCK_L (TermRep.fDyn ab) (TermRep.fDyn ac))::Document) ; _ -> error "Term explosion error."

_tc_DocumentTc = mkTyCon "Document"
instance Typeable Document where
    typeOf x = mkAppTy _tc_DocumentTc [ ]

instance Term Definition_block where
    explode (x::Definition_block) = TermRep (toDyn x, f x, g x) where
	f (TYPES aa) = [explode aa]
	f (STATES ab) = [explode ab]
	f (VALUES ac) = [explode ac]
	f (FUNCTIONS ad) = [explode ad]
	f (OPERATIONS ae) = [explode ae]
	g (TYPES _) xs = case TermRep.fArgs xs of [aa] -> toDyn ((TYPES (TermRep.fDyn aa))::Definition_block) ; _ -> error "Term explosion error."
	g (STATES _) xs = case TermRep.fArgs xs of [ab] -> toDyn ((STATES (TermRep.fDyn ab))::Definition_block) ; _ -> error "Term explosion error."
	g (VALUES _) xs = case TermRep.fArgs xs of [ac] -> toDyn ((VALUES (TermRep.fDyn ac))::Definition_block) ; _ -> error "Term explosion error."
	g (FUNCTIONS _) xs = case TermRep.fArgs xs of [ad] -> toDyn ((FUNCTIONS (TermRep.fDyn ad))::Definition_block) ; _ -> error "Term explosion error."
	g (OPERATIONS _) xs = case TermRep.fArgs xs of [ae] -> toDyn ((OPERATIONS (TermRep.fDyn ae))::Definition_block) ; _ -> error "Term explosion error."

_tc_Definition_blockTc = mkTyCon "Definition_block"
instance Typeable Definition_block where
    typeOf x = mkAppTy _tc_Definition_blockTc [ ]

instance Term Type_definition_list where
    explode (x::Type_definition_list) = TermRep (toDyn x, f x, g x) where
	f (TYPE_DEF aa) = [explode aa]
	g (TYPE_DEF _) xs = case TermRep.fArgs xs of [aa] -> toDyn ((TYPE_DEF (TermRep.fDyn aa))::Type_definition_list) ; _ -> error "Term explosion error."

_tc_Type_definition_listTc = mkTyCon "Type_definition_list"
instance Typeable Type_definition_list where
    typeOf x = mkAppTy _tc_Type_definition_listTc [ ]

instance Term Type_definition where
    explode (x::Type_definition) = TermRep (toDyn x, f x, g x) where
	f (TYPE_TYPE aa ab) = [explode aa,explode ab]
	f (TYPE_TYPE_INV ac ad ae) = [explode ac,explode ad,explode ae]
	f (TYPE_FIELD_L af ag) = [explode af,explode ag]
	f (TYPE_FIELD_L_INV ah ai aj) = [explode ah,explode ai,explode aj]
	g (TYPE_TYPE _ _) xs = case TermRep.fArgs xs of [aa,ab] -> toDyn ((TYPE_TYPE (TermRep.fDyn aa) (TermRep.fDyn ab))::Type_definition) ; _ -> error "Term explosion error."
	g (TYPE_TYPE_INV _ _ _) xs = case TermRep.fArgs xs of [ac,ad,ae] -> toDyn ((TYPE_TYPE_INV (TermRep.fDyn ac) (TermRep.fDyn ad) (TermRep.fDyn ae))::Type_definition) ; _ -> error "Term explosion error."
	g (TYPE_FIELD_L _ _) xs = case TermRep.fArgs xs of [af,ag] -> toDyn ((TYPE_FIELD_L (TermRep.fDyn af) (TermRep.fDyn ag))::Type_definition) ; _ -> error "Term explosion error."
	g (TYPE_FIELD_L_INV _ _ _) xs = case TermRep.fArgs xs of [ah,ai,aj] -> toDyn ((TYPE_FIELD_L_INV (TermRep.fDyn ah) (TermRep.fDyn ai) (TermRep.fDyn aj))::Type_definition) ; _ -> error "Term explosion error."

_tc_Type_definitionTc = mkTyCon "Type_definition"
instance Typeable Type_definition where
    typeOf x = mkAppTy _tc_Type_definitionTc [ ]

instance Term Type_list where
    explode (x::Type_list) = TermRep (toDyn x, f x, g x) where
	f (TYPE_S aa) = [explode aa]
	f (TYPE_L ab ac) = [explode ab,explode ac]
	g (TYPE_S _) xs = case TermRep.fArgs xs of [aa] -> toDyn ((TYPE_S (TermRep.fDyn aa))::Type_list) ; _ -> error "Term explosion error."
	g (TYPE_L _ _) xs = case TermRep.fArgs xs of [ab,ac] -> toDyn ((TYPE_L (TermRep.fDyn ab) (TermRep.fDyn ac))::Type_list) ; _ -> error "Term explosion error."

_tc_Type_listTc = mkTyCon "Type_list"
instance Typeable Type_list where
    typeOf x = mkAppTy _tc_Type_listTc [ ]

instance Term Type where
    explode (x::Type) = TermRep (toDyn x, f x, g x) where
	f (BRACK_TYPE aa) = [explode aa]
	f BOOL = []
	f NAT = []
	f NAT1 = []
	f INT = []
	f RAT = []
	f REAL = []
	f CHAR = []
	f TOKEN = []
	f (QUOTE_TYPE ab) = [explode ab]
	f (COMPOSE ac ad) = [explode ac,explode ad]
	f (UNION_TYPE ae af) = [explode ae,explode af]
	f (PROD_TYPE ag ah) = [explode ag,explode ah]
	f (OPT_TYPE ai) = [explode ai]
	f (SET_OF aj) = [explode aj]
	f (SEQ0_OF ak) = [explode ak]
	f (SEQ1_OF al) = [explode al]
	f (MAP_TYPE am an) = [explode am,explode an]
	f (INMAP_TYPE ao ap) = [explode ao,explode ap]
	f (FUNC_TYPE aq) = [explode aq]
	f (TYPE_VAR ar) = [explode ar]
	f (NAME_TYPE as) = [explode as]
	f NIL_TYPE = []
	g (BRACK_TYPE _) xs = case TermRep.fArgs xs of [aa] -> toDyn ((BRACK_TYPE (TermRep.fDyn aa))::Type) ; _ -> error "Term explosion error."
	g BOOL xs = case TermRep.fArgs xs of [] -> toDyn ((BOOL)::Type) ; _ -> error "Term explosion error."
	g NAT xs = case TermRep.fArgs xs of [] -> toDyn ((NAT)::Type) ; _ -> error "Term explosion error."
	g NAT1 xs = case TermRep.fArgs xs of [] -> toDyn ((NAT1)::Type) ; _ -> error "Term explosion error."
	g INT xs = case TermRep.fArgs xs of [] -> toDyn ((INT)::Type) ; _ -> error "Term explosion error."
	g RAT xs = case TermRep.fArgs xs of [] -> toDyn ((RAT)::Type) ; _ -> error "Term explosion error."
	g REAL xs = case TermRep.fArgs xs of [] -> toDyn ((REAL)::Type) ; _ -> error "Term explosion error."
	g CHAR xs = case TermRep.fArgs xs of [] -> toDyn ((CHAR)::Type) ; _ -> error "Term explosion error."
	g TOKEN xs = case TermRep.fArgs xs of [] -> toDyn ((TOKEN)::Type) ; _ -> error "Term explosion error."
	g (QUOTE_TYPE _) xs = case TermRep.fArgs xs of [ab] -> toDyn ((QUOTE_TYPE (TermRep.fDyn ab))::Type) ; _ -> error "Term explosion error."
	g (COMPOSE _ _) xs = case TermRep.fArgs xs of [ac,ad] -> toDyn ((COMPOSE (TermRep.fDyn ac) (TermRep.fDyn ad))::Type) ; _ -> error "Term explosion error."
	g (UNION_TYPE _ _) xs = case TermRep.fArgs xs of [ae,af] -> toDyn ((UNION_TYPE (TermRep.fDyn ae) (TermRep.fDyn af))::Type) ; _ -> error "Term explosion error."
	g (PROD_TYPE _ _) xs = case TermRep.fArgs xs of [ag,ah] -> toDyn ((PROD_TYPE (TermRep.fDyn ag) (TermRep.fDyn ah))::Type) ; _ -> error "Term explosion error."
	g (OPT_TYPE _) xs = case TermRep.fArgs xs of [ai] -> toDyn ((OPT_TYPE (TermRep.fDyn ai))::Type) ; _ -> error "Term explosion error."
	g (SET_OF _) xs = case TermRep.fArgs xs of [aj] -> toDyn ((SET_OF (TermRep.fDyn aj))::Type) ; _ -> error "Term explosion error."
	g (SEQ0_OF _) xs = case TermRep.fArgs xs of [ak] -> toDyn ((SEQ0_OF (TermRep.fDyn ak))::Type) ; _ -> error "Term explosion error."
	g (SEQ1_OF _) xs = case TermRep.fArgs xs of [al] -> toDyn ((SEQ1_OF (TermRep.fDyn al))::Type) ; _ -> error "Term explosion error."
	g (MAP_TYPE _ _) xs = case TermRep.fArgs xs of [am,an] -> toDyn ((MAP_TYPE (TermRep.fDyn am) (TermRep.fDyn an))::Type) ; _ -> error "Term explosion error."
	g (INMAP_TYPE _ _) xs = case TermRep.fArgs xs of [ao,ap] -> toDyn ((INMAP_TYPE (TermRep.fDyn ao) (TermRep.fDyn ap))::Type) ; _ -> error "Term explosion error."
	g (FUNC_TYPE _) xs = case TermRep.fArgs xs of [aq] -> toDyn ((FUNC_TYPE (TermRep.fDyn aq))::Type) ; _ -> error "Term explosion error."
	g (TYPE_VAR _) xs = case TermRep.fArgs xs of [ar] -> toDyn ((TYPE_VAR (TermRep.fDyn ar))::Type) ; _ -> error "Term explosion error."
	g (NAME_TYPE _) xs = case TermRep.fArgs xs of [as] -> toDyn ((NAME_TYPE (TermRep.fDyn as))::Type) ; _ -> error "Term explosion error."
	g NIL_TYPE xs = case TermRep.fArgs xs of [] -> toDyn ((NIL_TYPE)::Type) ; _ -> error "Term explosion error."

_tc_TypeTc = mkTyCon "Type"
instance Typeable Type where
    typeOf x = mkAppTy _tc_TypeTc [ ]

instance Term Function_type where
    explode (x::Function_type) = TermRep (toDyn x, f x, g x) where
	f (TOT_FUNC aa ab) = [explode aa,explode ab]
	f (TOT_FUNC0 ac) = [explode ac]
	f (PART_FUNC ad ae) = [explode ad,explode ae]
	f (PART_FUNC0 af) = [explode af]
	g (TOT_FUNC _ _) xs = case TermRep.fArgs xs of [aa,ab] -> toDyn ((TOT_FUNC (TermRep.fDyn aa) (TermRep.fDyn ab))::Function_type) ; _ -> error "Term explosion error."
	g (TOT_FUNC0 _) xs = case TermRep.fArgs xs of [ac] -> toDyn ((TOT_FUNC0 (TermRep.fDyn ac))::Function_type) ; _ -> error "Term explosion error."
	g (PART_FUNC _ _) xs = case TermRep.fArgs xs of [ad,ae] -> toDyn ((PART_FUNC (TermRep.fDyn ad) (TermRep.fDyn ae))::Function_type) ; _ -> error "Term explosion error."
	g (PART_FUNC0 _) xs = case TermRep.fArgs xs of [af] -> toDyn ((PART_FUNC0 (TermRep.fDyn af))::Function_type) ; _ -> error "Term explosion error."

_tc_Function_typeTc = mkTyCon "Function_type"
instance Typeable Function_type where
    typeOf x = mkAppTy _tc_Function_typeTc [ ]

instance Term Discretionary_type where
    explode (x::Discretionary_type) = TermRep (toDyn x, f x, g x) where
	f (SOME aa) = [explode aa]
	f NOTH = []
	g (SOME _) xs = case TermRep.fArgs xs of [aa] -> toDyn ((SOME (TermRep.fDyn aa))::Discretionary_type) ; _ -> error "Term explosion error."
	g NOTH xs = case TermRep.fArgs xs of [] -> toDyn ((NOTH)::Discretionary_type) ; _ -> error "Term explosion error."

_tc_Discretionary_typeTc = mkTyCon "Discretionary_type"
instance Typeable Discretionary_type where
    typeOf x = mkAppTy _tc_Discretionary_typeTc [ ]

instance Term Field_list where
    explode (x::Field_list) = TermRep (toDyn x, f x, g x) where
	f (FIELD_LIST aa) = [explode aa]
	g (FIELD_LIST _) xs = case TermRep.fArgs xs of [aa] -> toDyn ((FIELD_LIST (TermRep.fDyn aa))::Field_list) ; _ -> error "Term explosion error."

_tc_Field_listTc = mkTyCon "Field_list"
instance Typeable Field_list where
    typeOf x = mkAppTy _tc_Field_listTc [ ]

instance Term Field where
    explode (x::Field) = TermRep (toDyn x, f x, g x) where
	f (FIELD_NAME aa ab) = [explode aa,explode ab]
	f (FIELD_NAME_IGNORE ac ad) = [explode ac,explode ad]
	f (FIELD_TYPE ae) = [explode ae]
	g (FIELD_NAME _ _) xs = case TermRep.fArgs xs of [aa,ab] -> toDyn ((FIELD_NAME (TermRep.fDyn aa) (TermRep.fDyn ab))::Field) ; _ -> error "Term explosion error."
	g (FIELD_NAME_IGNORE _ _) xs = case TermRep.fArgs xs of [ac,ad] -> toDyn ((FIELD_NAME_IGNORE (TermRep.fDyn ac) (TermRep.fDyn ad))::Field) ; _ -> error "Term explosion error."
	g (FIELD_TYPE _) xs = case TermRep.fArgs xs of [ae] -> toDyn ((FIELD_TYPE (TermRep.fDyn ae))::Field) ; _ -> error "Term explosion error."

_tc_FieldTc = mkTyCon "Field"
instance Typeable Field where
    typeOf x = mkAppTy _tc_FieldTc [ ]

instance Term State_definition where
    explode (x::State_definition) = TermRep (toDyn x, f x, g x) where
	f (STATE aa ab) = [explode aa,explode ab]
	f (STATE_INV ac ad ae) = [explode ac,explode ad,explode ae]
	f (STATE_INI af ag ah) = [explode af,explode ag,explode ah]
	f (STATE_INV_INI ai aj ak al) = [explode ai,explode aj,explode ak,explode al]
	g (STATE _ _) xs = case TermRep.fArgs xs of [aa,ab] -> toDyn ((STATE (TermRep.fDyn aa) (TermRep.fDyn ab))::State_definition) ; _ -> error "Term explosion error."
	g (STATE_INV _ _ _) xs = case TermRep.fArgs xs of [ac,ad,ae] -> toDyn ((STATE_INV (TermRep.fDyn ac) (TermRep.fDyn ad) (TermRep.fDyn ae))::State_definition) ; _ -> error "Term explosion error."
	g (STATE_INI _ _ _) xs = case TermRep.fArgs xs of [af,ag,ah] -> toDyn ((STATE_INI (TermRep.fDyn af) (TermRep.fDyn ag) (TermRep.fDyn ah))::State_definition) ; _ -> error "Term explosion error."
	g (STATE_INV_INI _ _ _ _) xs = case TermRep.fArgs xs of [ai,aj,ak,al] -> toDyn ((STATE_INV_INI (TermRep.fDyn ai) (TermRep.fDyn aj) (TermRep.fDyn ak) (TermRep.fDyn al))::State_definition) ; _ -> error "Term explosion error."

_tc_State_definitionTc = mkTyCon "State_definition"
instance Typeable State_definition where
    typeOf x = mkAppTy _tc_State_definitionTc [ ]

instance Term Invariant where
    explode (x::Invariant) = TermRep (toDyn x, f x, g x) where
	f (INVARIANT aa ab) = [explode aa,explode ab]
	g (INVARIANT _ _) xs = case TermRep.fArgs xs of [aa,ab] -> toDyn ((INVARIANT (TermRep.fDyn aa) (TermRep.fDyn ab))::Invariant) ; _ -> error "Term explosion error."

_tc_InvariantTc = mkTyCon "Invariant"
instance Typeable Invariant where
    typeOf x = mkAppTy _tc_InvariantTc [ ]

instance Term Initialization where
    explode (x::Initialization) = TermRep (toDyn x, f x, g x) where
	f (INITIALIZATION aa ab) = [explode aa,explode ab]
	g (INITIALIZATION _ _) xs = case TermRep.fArgs xs of [aa,ab] -> toDyn ((INITIALIZATION (TermRep.fDyn aa) (TermRep.fDyn ab))::Initialization) ; _ -> error "Term explosion error."

_tc_InitializationTc = mkTyCon "Initialization"
instance Typeable Initialization where
    typeOf x = mkAppTy _tc_InitializationTc [ ]

instance Term Value_definition_list where
    explode (x::Value_definition_list) = TermRep (toDyn x, f x, g x) where
	f (VAL_DEF_S aa) = [explode aa]
	f (VAL_DEF_L ab ac) = [explode ab,explode ac]
	g (VAL_DEF_S _) xs = case TermRep.fArgs xs of [aa] -> toDyn ((VAL_DEF_S (TermRep.fDyn aa))::Value_definition_list) ; _ -> error "Term explosion error."
	g (VAL_DEF_L _ _) xs = case TermRep.fArgs xs of [ab,ac] -> toDyn ((VAL_DEF_L (TermRep.fDyn ab) (TermRep.fDyn ac))::Value_definition_list) ; _ -> error "Term explosion error."

_tc_Value_definition_listTc = mkTyCon "Value_definition_list"
instance Typeable Value_definition_list where
    typeOf x = mkAppTy _tc_Value_definition_listTc [ ]

instance Term Value_definition where
    explode (x::Value_definition) = TermRep (toDyn x, f x, g x) where
	f (PATTERN aa ab) = [explode aa,explode ab]
	f (PATTERN_TYPE ac ad ae) = [explode ac,explode ad,explode ae]
	g (PATTERN _ _) xs = case TermRep.fArgs xs of [aa,ab] -> toDyn ((PATTERN (TermRep.fDyn aa) (TermRep.fDyn ab))::Value_definition) ; _ -> error "Term explosion error."
	g (PATTERN_TYPE _ _ _) xs = case TermRep.fArgs xs of [ac,ad,ae] -> toDyn ((PATTERN_TYPE (TermRep.fDyn ac) (TermRep.fDyn ad) (TermRep.fDyn ae))::Value_definition) ; _ -> error "Term explosion error."

_tc_Value_definitionTc = mkTyCon "Value_definition"
instance Typeable Value_definition where
    typeOf x = mkAppTy _tc_Value_definitionTc [ ]

instance Term Function_definition_list where
    explode (x::Function_definition_list) = TermRep (toDyn x, f x, g x) where
	f (FUNC_DEF_S aa) = [explode aa]
	f (FUNC_DEF_L ab ac) = [explode ab,explode ac]
	g (FUNC_DEF_S _) xs = case TermRep.fArgs xs of [aa] -> toDyn ((FUNC_DEF_S (TermRep.fDyn aa))::Function_definition_list) ; _ -> error "Term explosion error."
	g (FUNC_DEF_L _ _) xs = case TermRep.fArgs xs of [ab,ac] -> toDyn ((FUNC_DEF_L (TermRep.fDyn ab) (TermRep.fDyn ac))::Function_definition_list) ; _ -> error "Term explosion error."

_tc_Function_definition_listTc = mkTyCon "Function_definition_list"
instance Typeable Function_definition_list where
    typeOf x = mkAppTy _tc_Function_definition_listTc [ ]

instance Term Function_definition where
    explode (x::Function_definition) = TermRep (toDyn x, f x, g x) where
	f (EXPL_FUNC_DEF aa) = [explode aa]
	f (IMPL_FUNC_DEF ab) = [explode ab]
	g (EXPL_FUNC_DEF _) xs = case TermRep.fArgs xs of [aa] -> toDyn ((EXPL_FUNC_DEF (TermRep.fDyn aa))::Function_definition) ; _ -> error "Term explosion error."
	g (IMPL_FUNC_DEF _) xs = case TermRep.fArgs xs of [ab] -> toDyn ((IMPL_FUNC_DEF (TermRep.fDyn ab))::Function_definition) ; _ -> error "Term explosion error."

_tc_Function_definitionTc = mkTyCon "Function_definition"
instance Typeable Function_definition where
    typeOf x = mkAppTy _tc_Function_definitionTc [ ]

instance Term Explicit_function_definition where
    explode (x::Explicit_function_definition) = TermRep (toDyn x, f x, g x) where
	f (EXPL_FUNC aa ab ac ad ae af) = [explode aa,explode ab,explode ac,explode ad,explode ae,explode af]
	f (EXPL_FUNC_TYPE_VAR ag ah ai aj ak al am) = [explode ag,explode ah,explode ai,explode aj,explode ak,explode al,explode am]
	g (EXPL_FUNC _ _ _ _ _ _) xs = case TermRep.fArgs xs of [aa,ab,ac,ad,ae,af] -> toDyn ((EXPL_FUNC (TermRep.fDyn aa) (TermRep.fDyn ab) (TermRep.fDyn ac) (TermRep.fDyn ad) (TermRep.fDyn ae) (TermRep.fDyn af))::Explicit_function_definition) ; _ -> error "Term explosion error."
	g (EXPL_FUNC_TYPE_VAR _ _ _ _ _ _ _) xs = case TermRep.fArgs xs of [ag,ah,ai,aj,ak,al,am] -> toDyn ((EXPL_FUNC_TYPE_VAR (TermRep.fDyn ag) (TermRep.fDyn ah) (TermRep.fDyn ai) (TermRep.fDyn aj) (TermRep.fDyn ak) (TermRep.fDyn al) (TermRep.fDyn am))::Explicit_function_definition) ; _ -> error "Term explosion error."

_tc_Explicit_function_definitionTc = mkTyCon "Explicit_function_definition"
instance Typeable Explicit_function_definition where
    typeOf x = mkAppTy _tc_Explicit_function_definitionTc [ ]

instance Term Implicit_function_definition where
    explode (x::Implicit_function_definition) = TermRep (toDyn x, f x, g x) where
	f (IMPL_FUNC aa ab ac ad ae af) = [explode aa,explode ab,explode ac,explode ad,explode ae,explode af]
	f (IMPL_FUNC_TYPE ag ah ai aj ak al am) = [explode ag,explode ah,explode ai,explode aj,explode ak,explode al,explode am]
	g (IMPL_FUNC _ _ _ _ _ _) xs = case TermRep.fArgs xs of [aa,ab,ac,ad,ae,af] -> toDyn ((IMPL_FUNC (TermRep.fDyn aa) (TermRep.fDyn ab) (TermRep.fDyn ac) (TermRep.fDyn ad) (TermRep.fDyn ae) (TermRep.fDyn af))::Implicit_function_definition) ; _ -> error "Term explosion error."
	g (IMPL_FUNC_TYPE _ _ _ _ _ _ _) xs = case TermRep.fArgs xs of [ag,ah,ai,aj,ak,al,am] -> toDyn ((IMPL_FUNC_TYPE (TermRep.fDyn ag) (TermRep.fDyn ah) (TermRep.fDyn ai) (TermRep.fDyn aj) (TermRep.fDyn ak) (TermRep.fDyn al) (TermRep.fDyn am))::Implicit_function_definition) ; _ -> error "Term explosion error."

_tc_Implicit_function_definitionTc = mkTyCon "Implicit_function_definition"
instance Typeable Implicit_function_definition where
    typeOf x = mkAppTy _tc_Implicit_function_definitionTc [ ]

instance Term Type_variable_list where
    explode (x::Type_variable_list) = TermRep (toDyn x, f x, g x) where
	f (TYPE_VAR_S aa) = [explode aa]
	f (TYPE_VAR_L ab ac) = [explode ab,explode ac]
	g (TYPE_VAR_S _) xs = case TermRep.fArgs xs of [aa] -> toDyn ((TYPE_VAR_S (TermRep.fDyn aa))::Type_variable_list) ; _ -> error "Term explosion error."
	g (TYPE_VAR_L _ _) xs = case TermRep.fArgs xs of [ab,ac] -> toDyn ((TYPE_VAR_L (TermRep.fDyn ab) (TermRep.fDyn ac))::Type_variable_list) ; _ -> error "Term explosion error."

_tc_Type_variable_listTc = mkTyCon "Type_variable_list"
instance Typeable Type_variable_list where
    typeOf x = mkAppTy _tc_Type_variable_listTc [ ]

instance Term Parameter_type_list where
    explode (x::Parameter_type_list) = TermRep (toDyn x, f x, g x) where
	f PARAM_TYPE_E = []
	f (PARAM_TYPE_L aa) = [explode aa]
	g PARAM_TYPE_E xs = case TermRep.fArgs xs of [] -> toDyn ((PARAM_TYPE_E)::Parameter_type_list) ; _ -> error "Term explosion error."
	g (PARAM_TYPE_L _) xs = case TermRep.fArgs xs of [aa] -> toDyn ((PARAM_TYPE_L (TermRep.fDyn aa))::Parameter_type_list) ; _ -> error "Term explosion error."

_tc_Parameter_type_listTc = mkTyCon "Parameter_type_list"
instance Typeable Parameter_type_list where
    typeOf x = mkAppTy _tc_Parameter_type_listTc [ ]

instance Term Pattern_type_pair_list where
    explode (x::Pattern_type_pair_list) = TermRep (toDyn x, f x, g x) where
	f (PAT_TYPE_S aa ab) = [explode aa,explode ab]
	f (PAT_TYPE_L ac ad ae) = [explode ac,explode ad,explode ae]
	g (PAT_TYPE_S _ _) xs = case TermRep.fArgs xs of [aa,ab] -> toDyn ((PAT_TYPE_S (TermRep.fDyn aa) (TermRep.fDyn ab))::Pattern_type_pair_list) ; _ -> error "Term explosion error."
	g (PAT_TYPE_L _ _ _) xs = case TermRep.fArgs xs of [ac,ad,ae] -> toDyn ((PAT_TYPE_L (TermRep.fDyn ac) (TermRep.fDyn ad) (TermRep.fDyn ae))::Pattern_type_pair_list) ; _ -> error "Term explosion error."

_tc_Pattern_type_pair_listTc = mkTyCon "Pattern_type_pair_list"
instance Typeable Pattern_type_pair_list where
    typeOf x = mkAppTy _tc_Pattern_type_pair_listTc [ ]

instance Term Parameters_list where
    explode (x::Parameters_list) = TermRep (toDyn x, f x, g x) where
	f (PARAM_S aa) = [explode aa]
	f (PARAM_L ab ac) = [explode ab,explode ac]
	g (PARAM_S _) xs = case TermRep.fArgs xs of [aa] -> toDyn ((PARAM_S (TermRep.fDyn aa))::Parameters_list) ; _ -> error "Term explosion error."
	g (PARAM_L _ _) xs = case TermRep.fArgs xs of [ab,ac] -> toDyn ((PARAM_L (TermRep.fDyn ab) (TermRep.fDyn ac))::Parameters_list) ; _ -> error "Term explosion error."

_tc_Parameters_listTc = mkTyCon "Parameters_list"
instance Typeable Parameters_list where
    typeOf x = mkAppTy _tc_Parameters_listTc [ ]

instance Term Brack_maybe_pattern_list where
    explode (x::Brack_maybe_pattern_list) = TermRep (toDyn x, f x, g x) where
	f BRACK_MAY_NOTH = []
	f (BRACK_MAY_JUST aa) = [explode aa]
	g BRACK_MAY_NOTH xs = case TermRep.fArgs xs of [] -> toDyn ((BRACK_MAY_NOTH)::Brack_maybe_pattern_list) ; _ -> error "Term explosion error."
	g (BRACK_MAY_JUST _) xs = case TermRep.fArgs xs of [aa] -> toDyn ((BRACK_MAY_JUST (TermRep.fDyn aa))::Brack_maybe_pattern_list) ; _ -> error "Term explosion error."

_tc_Brack_maybe_pattern_listTc = mkTyCon "Brack_maybe_pattern_list"
instance Typeable Brack_maybe_pattern_list where
    typeOf x = mkAppTy _tc_Brack_maybe_pattern_listTc [ ]

instance Term Maybe_precondition where
    explode (x::Maybe_precondition) = TermRep (toDyn x, f x, g x) where
	f MAY_PRECOND_NOTH = []
	f (MAY_PRECOND_JUST aa) = [explode aa]
	g MAY_PRECOND_NOTH xs = case TermRep.fArgs xs of [] -> toDyn ((MAY_PRECOND_NOTH)::Maybe_precondition) ; _ -> error "Term explosion error."
	g (MAY_PRECOND_JUST _) xs = case TermRep.fArgs xs of [aa] -> toDyn ((MAY_PRECOND_JUST (TermRep.fDyn aa))::Maybe_precondition) ; _ -> error "Term explosion error."

_tc_Maybe_preconditionTc = mkTyCon "Maybe_precondition"
instance Typeable Maybe_precondition where
    typeOf x = mkAppTy _tc_Maybe_preconditionTc [ ]

instance Term Operation_definition_list where
    explode (x::Operation_definition_list) = TermRep (toDyn x, f x, g x) where
	f (OPER_DEF_S aa) = [explode aa]
	f (OPER_DEF_L ab ac) = [explode ab,explode ac]
	g (OPER_DEF_S _) xs = case TermRep.fArgs xs of [aa] -> toDyn ((OPER_DEF_S (TermRep.fDyn aa))::Operation_definition_list) ; _ -> error "Term explosion error."
	g (OPER_DEF_L _ _) xs = case TermRep.fArgs xs of [ab,ac] -> toDyn ((OPER_DEF_L (TermRep.fDyn ab) (TermRep.fDyn ac))::Operation_definition_list) ; _ -> error "Term explosion error."

_tc_Operation_definition_listTc = mkTyCon "Operation_definition_list"
instance Typeable Operation_definition_list where
    typeOf x = mkAppTy _tc_Operation_definition_listTc [ ]

instance Term Operation_definition where
    explode (x::Operation_definition) = TermRep (toDyn x, f x, g x) where
	f (EXPL_OPER_DEF aa) = [explode aa]
	f (IMPL_OPER_DEF ab) = [explode ab]
	g (EXPL_OPER_DEF _) xs = case TermRep.fArgs xs of [aa] -> toDyn ((EXPL_OPER_DEF (TermRep.fDyn aa))::Operation_definition) ; _ -> error "Term explosion error."
	g (IMPL_OPER_DEF _) xs = case TermRep.fArgs xs of [ab] -> toDyn ((IMPL_OPER_DEF (TermRep.fDyn ab))::Operation_definition) ; _ -> error "Term explosion error."

_tc_Operation_definitionTc = mkTyCon "Operation_definition"
instance Typeable Operation_definition where
    typeOf x = mkAppTy _tc_Operation_definitionTc [ ]

instance Term Explicit_operation_definition where
    explode (x::Explicit_operation_definition) = TermRep (toDyn x, f x, g x) where
	f (EXPL_OPER aa ab ac ad ae af ag) = [explode aa,explode ab,explode ac,explode ad,explode ae,explode af,explode ag]
	g (EXPL_OPER _ _ _ _ _ _ _) xs = case TermRep.fArgs xs of [aa,ab,ac,ad,ae,af,ag] -> toDyn ((EXPL_OPER (TermRep.fDyn aa) (TermRep.fDyn ab) (TermRep.fDyn ac) (TermRep.fDyn ad) (TermRep.fDyn ae) (TermRep.fDyn af) (TermRep.fDyn ag))::Explicit_operation_definition) ; _ -> error "Term explosion error."

_tc_Explicit_operation_definitionTc = mkTyCon "Explicit_operation_definition"
instance Typeable Explicit_operation_definition where
    typeOf x = mkAppTy _tc_Explicit_operation_definitionTc [ ]

instance Term Implicit_operation_definition where
    explode (x::Implicit_operation_definition) = TermRep (toDyn x, f x, g x) where
	f (IMPL_OPER aa ab ac ad ae) = [explode aa,explode ab,explode ac,explode ad,explode ae]
	f (IMPL_OPER_EXCEP af ag ah ai aj ak) = [explode af,explode ag,explode ah,explode ai,explode aj,explode ak]
	f (IMPL_OPER_TYPE al am an ao ap aq ar) = [explode al,explode am,explode an,explode ao,explode ap,explode aq,explode ar]
	f (IMPL_OPER_TYPE_EXCEP as at au av aw ax ay az) = [explode as,explode at,explode au,explode av,explode aw,explode ax,explode ay,explode az]
	g (IMPL_OPER _ _ _ _ _) xs = case TermRep.fArgs xs of [aa,ab,ac,ad,ae] -> toDyn ((IMPL_OPER (TermRep.fDyn aa) (TermRep.fDyn ab) (TermRep.fDyn ac) (TermRep.fDyn ad) (TermRep.fDyn ae))::Implicit_operation_definition) ; _ -> error "Term explosion error."
	g (IMPL_OPER_EXCEP _ _ _ _ _ _) xs = case TermRep.fArgs xs of [af,ag,ah,ai,aj,ak] -> toDyn ((IMPL_OPER_EXCEP (TermRep.fDyn af) (TermRep.fDyn ag) (TermRep.fDyn ah) (TermRep.fDyn ai) (TermRep.fDyn aj) (TermRep.fDyn ak))::Implicit_operation_definition) ; _ -> error "Term explosion error."
	g (IMPL_OPER_TYPE _ _ _ _ _ _ _) xs = case TermRep.fArgs xs of [al,am,an,ao,ap,aq,ar] -> toDyn ((IMPL_OPER_TYPE (TermRep.fDyn al) (TermRep.fDyn am) (TermRep.fDyn an) (TermRep.fDyn ao) (TermRep.fDyn ap) (TermRep.fDyn aq) (TermRep.fDyn ar))::Implicit_operation_definition) ; _ -> error "Term explosion error."
	g (IMPL_OPER_TYPE_EXCEP _ _ _ _ _ _ _ _) xs = case TermRep.fArgs xs of [as,at,au,av,aw,ax,ay,az] -> toDyn ((IMPL_OPER_TYPE_EXCEP (TermRep.fDyn as) (TermRep.fDyn at) (TermRep.fDyn au) (TermRep.fDyn av) (TermRep.fDyn aw) (TermRep.fDyn ax) (TermRep.fDyn ay) (TermRep.fDyn az))::Implicit_operation_definition) ; _ -> error "Term explosion error."

_tc_Implicit_operation_definitionTc = mkTyCon "Implicit_operation_definition"
instance Typeable Implicit_operation_definition where
    typeOf x = mkAppTy _tc_Implicit_operation_definitionTc [ ]

instance Term Maybe_externals where
    explode (x::Maybe_externals) = TermRep (toDyn x, f x, g x) where
	f MAY_EXTERN_NOTH = []
	f (MAY_EXTERN_JUST aa) = [explode aa]
	g MAY_EXTERN_NOTH xs = case TermRep.fArgs xs of [] -> toDyn ((MAY_EXTERN_NOTH)::Maybe_externals) ; _ -> error "Term explosion error."
	g (MAY_EXTERN_JUST _) xs = case TermRep.fArgs xs of [aa] -> toDyn ((MAY_EXTERN_JUST (TermRep.fDyn aa))::Maybe_externals) ; _ -> error "Term explosion error."

_tc_Maybe_externalsTc = mkTyCon "Maybe_externals"
instance Typeable Maybe_externals where
    typeOf x = mkAppTy _tc_Maybe_externalsTc [ ]

instance Term External_list where
    explode (x::External_list) = TermRep (toDyn x, f x, g x) where
	f (EXTERNAL_S aa) = [explode aa]
	f (EXTERNAL_L ab ac) = [explode ab,explode ac]
	g (EXTERNAL_S _) xs = case TermRep.fArgs xs of [aa] -> toDyn ((EXTERNAL_S (TermRep.fDyn aa))::External_list) ; _ -> error "Term explosion error."
	g (EXTERNAL_L _ _) xs = case TermRep.fArgs xs of [ab,ac] -> toDyn ((EXTERNAL_L (TermRep.fDyn ab) (TermRep.fDyn ac))::External_list) ; _ -> error "Term explosion error."

_tc_External_listTc = mkTyCon "External_list"
instance Typeable External_list where
    typeOf x = mkAppTy _tc_External_listTc [ ]

instance Term Var_information where
    explode (x::Var_information) = TermRep (toDyn x, f x, g x) where
	f (RD aa) = [explode aa]
	f (WR ab) = [explode ab]
	f (RD_TYPE ac ad) = [explode ac,explode ad]
	f (WR_TYPE ae af) = [explode ae,explode af]
	g (RD _) xs = case TermRep.fArgs xs of [aa] -> toDyn ((RD (TermRep.fDyn aa))::Var_information) ; _ -> error "Term explosion error."
	g (WR _) xs = case TermRep.fArgs xs of [ab] -> toDyn ((WR (TermRep.fDyn ab))::Var_information) ; _ -> error "Term explosion error."
	g (RD_TYPE _ _) xs = case TermRep.fArgs xs of [ac,ad] -> toDyn ((RD_TYPE (TermRep.fDyn ac) (TermRep.fDyn ad))::Var_information) ; _ -> error "Term explosion error."
	g (WR_TYPE _ _) xs = case TermRep.fArgs xs of [ae,af] -> toDyn ((WR_TYPE (TermRep.fDyn ae) (TermRep.fDyn af))::Var_information) ; _ -> error "Term explosion error."

_tc_Var_informationTc = mkTyCon "Var_information"
instance Typeable Var_information where
    typeOf x = mkAppTy _tc_Var_informationTc [ ]

instance Term Exception_list where
    explode (x::Exception_list) = TermRep (toDyn x, f x, g x) where
	f (EXCEPT_S aa ab ac) = [explode aa,explode ab,explode ac]
	f (EXCEPT_L ad ae af ag) = [explode ad,explode ae,explode af,explode ag]
	g (EXCEPT_S _ _ _) xs = case TermRep.fArgs xs of [aa,ab,ac] -> toDyn ((EXCEPT_S (TermRep.fDyn aa) (TermRep.fDyn ab) (TermRep.fDyn ac))::Exception_list) ; _ -> error "Term explosion error."
	g (EXCEPT_L _ _ _ _) xs = case TermRep.fArgs xs of [ad,ae,af,ag] -> toDyn ((EXCEPT_L (TermRep.fDyn ad) (TermRep.fDyn ae) (TermRep.fDyn af) (TermRep.fDyn ag))::Exception_list) ; _ -> error "Term explosion error."

_tc_Exception_listTc = mkTyCon "Exception_list"
instance Typeable Exception_list where
    typeOf x = mkAppTy _tc_Exception_listTc [ ]

instance Term Expression_list where
    explode (x::Expression_list) = TermRep (toDyn x, f x, g x) where
	f (EXPR_S aa) = [explode aa]
	f (EXPR_L ab ac) = [explode ab,explode ac]
	g (EXPR_S _) xs = case TermRep.fArgs xs of [aa] -> toDyn ((EXPR_S (TermRep.fDyn aa))::Expression_list) ; _ -> error "Term explosion error."
	g (EXPR_L _ _) xs = case TermRep.fArgs xs of [ab,ac] -> toDyn ((EXPR_L (TermRep.fDyn ab) (TermRep.fDyn ac))::Expression_list) ; _ -> error "Term explosion error."

_tc_Expression_listTc = mkTyCon "Expression_list"
instance Typeable Expression_list where
    typeOf x = mkAppTy _tc_Expression_listTc [ ]

instance Term Expression where
    explode (x::Expression) = TermRep (toDyn x, f x, g x) where
	f (BRACK_EXPR aa) = [explode aa]
	f (LET ab ac) = [explode ab,explode ac]
	f (LET_INSET ad ae af) = [explode ad,explode ae,explode af]
	f (LET_VAR ag ah ai) = [explode ag,explode ah,explode ai]
	f (LET_PAT aj ak al) = [explode aj,explode ak,explode al]
	f (LETBE_INSET am an ao ap) = [explode am,explode an,explode ao,explode ap]
	f (LETBE_VAR aq ar as at) = [explode aq,explode ar,explode as,explode at]
	f (LETBE_PAT au av aw ax) = [explode au,explode av,explode aw,explode ax]
	f (DEF ay az) = [explode ay,explode az]
	f (IF_EXPR aA) = [explode aA]
	f (CASE aB aC) = [explode aB,explode aC]
	f (CASE_OTHER aD aE aF) = [explode aD,explode aE,explode aF]
	f (PLUS aG) = [explode aG]
	f (MINUS aH) = [explode aH]
	f (ABS aI) = [explode aI]
	f (FLOOR aJ) = [explode aJ]
	f (NOT aK) = [explode aK]
	f (CARD aL) = [explode aL]
	f (POWER aM) = [explode aM]
	f (DUNION aN) = [explode aN]
	f (DINTER aO) = [explode aO]
	f (HD aP) = [explode aP]
	f (TL aQ) = [explode aQ]
	f (LEN aR) = [explode aR]
	f (ELEMS aS) = [explode aS]
	f (INDS aT) = [explode aT]
	f (CONC aU) = [explode aU]
	f (DOM aV) = [explode aV]
	f (RANGE aW) = [explode aW]
	f (MERGE1 aX) = [explode aX]
	f (INVERSE aY) = [explode aY]
	f (ADD aZ ba) = [explode aZ,explode ba]
	f (SUBTR bb bc) = [explode bb,explode bc]
	f (MULT bd be) = [explode bd,explode be]
	f (DIVIDE bf bg) = [explode bf,explode bg]
	f (DIV bh bi) = [explode bh,explode bi]
	f (REM bj bk) = [explode bj,explode bk]
	f (MOD bl bm) = [explode bl,explode bm]
	f (LESS bn bo) = [explode bn,explode bo]
	f (LESS_EQ bp bq) = [explode bp,explode bq]
	f (GREAT br bs) = [explode br,explode bs]
	f (GREAT_EQ bt bu) = [explode bt,explode bu]
	f (EQUAL bv bw) = [explode bv,explode bw]
	f (NEQ bx by) = [explode bx,explode by]
	f (OR bz bA) = [explode bz,explode bA]
	f (AND bB bC) = [explode bB,explode bC]
	f (IMPLY bD bE) = [explode bD,explode bE]
	f (EQUIV bF bG) = [explode bF,explode bG]
	f (IN_SET bH bI) = [explode bH,explode bI]
	f (NOT_IN_SET bJ bK) = [explode bJ,explode bK]
	f (SUBSET bL bM) = [explode bL,explode bM]
	f (PSUBSET bN bO) = [explode bN,explode bO]
	f (UNION bP bQ) = [explode bP,explode bQ]
	f (MERGE2 bR bS) = [explode bR,explode bS]
	f (SET_DIFF bT bU) = [explode bT,explode bU]
	f (INTER bV bW) = [explode bV,explode bW]
	f (CONCAT bX bY) = [explode bX,explode bY]
	f (MODIFY bZ ca) = [explode bZ,explode ca]
	f (MUNION cb cc) = [explode cb,explode cc]
	f (DOM_RESTR_TO cd ce) = [explode cd,explode ce]
	f (DOM_RESTR_BY cf cg) = [explode cf,explode cg]
	f (RNG_RESTR_TO ch ci) = [explode ch,explode ci]
	f (RNG_RESTR_BY cj ck) = [explode cj,explode ck]
	f (COMP cl cm) = [explode cl,explode cm]
	f (ITERATE cn co) = [explode cn,explode co]
	f (FORALL cp cq) = [explode cp,explode cq]
	f (EXISTS cr cs) = [explode cr,explode cs]
	f (EXISTS1 ct cu) = [explode ct,explode cu]
	f (IOTA cv cw) = [explode cv,explode cw]
	f EMPTY_SET = []
	f (SET cx) = [explode cx]
	f (SET2 cy cz) = [explode cy,explode cz]
	f (SET_ENUM cA cB cC) = [explode cA,explode cB,explode cC]
	f (COMPR_SET cD cE) = [explode cD,explode cE]
	f (COMPR_SET_COND cF cG cH) = [explode cF,explode cG,explode cH]
	f (RANGE_SET cI cJ) = [explode cI,explode cJ]
	f EMPTY_SEQ = []
	f (SEQ cK) = [explode cK]
	f (COMPR_SEQ cL cM) = [explode cL,explode cM]
	f (COMPR_SEQ_COND cN cO cP) = [explode cN,explode cO,explode cP]
	f (SUBSEQ cQ cR cS) = [explode cQ,explode cR,explode cS]
	f EMPTY_MAP = []
	f (MAP cT) = [explode cT]
	f (COMPR_MAP cU cV cW) = [explode cU,explode cV,explode cW]
	f (COMPR_MAP_COND cX cY cZ da) = [explode cX,explode cY,explode cZ,explode da]
	f (TUPLE db) = [explode db]
	f (RECORD_E dc) = [explode dc]
	f (RECORD_S dd de) = [explode dd,explode de]
	f (MU df dg) = [explode df,explode dg]
	f (APPLY0 dh) = [explode dh]
	f (APPLY1 di dj) = [explode di,explode dj]
	f (APPLYN dk dl dm) = [explode dk,explode dl,explode dm]
	f (FIELD_SEL dn do1) = [explode dn,explode do1]
	f (TUPLE_SEL dp dq) = [explode dp,explode dq]
	f (FUNCT_TYPE_INST dr ds) = [explode dr,explode ds]
	f (LAMBDA dt du) = [explode dt,explode du]
	f (IS_IDENT dv dw) = [explode dv,explode dw]
	f (IDENT dx) = [explode dx]
	f (OLD_NAME dy) = [explode dy]
	f (SYMB_LIT dz) = [explode dz]
	g (BRACK_EXPR _) xs = case TermRep.fArgs xs of [aa] -> toDyn ((BRACK_EXPR (TermRep.fDyn aa))::Expression) ; _ -> error "Term explosion error."
	g (LET _ _) xs = case TermRep.fArgs xs of [ab,ac] -> toDyn ((LET (TermRep.fDyn ab) (TermRep.fDyn ac))::Expression) ; _ -> error "Term explosion error."
	g (LET_INSET _ _ _) xs = case TermRep.fArgs xs of [ad,ae,af] -> toDyn ((LET_INSET (TermRep.fDyn ad) (TermRep.fDyn ae) (TermRep.fDyn af))::Expression) ; _ -> error "Term explosion error."
	g (LET_VAR _ _ _) xs = case TermRep.fArgs xs of [ag,ah,ai] -> toDyn ((LET_VAR (TermRep.fDyn ag) (TermRep.fDyn ah) (TermRep.fDyn ai))::Expression) ; _ -> error "Term explosion error."
	g (LET_PAT _ _ _) xs = case TermRep.fArgs xs of [aj,ak,al] -> toDyn ((LET_PAT (TermRep.fDyn aj) (TermRep.fDyn ak) (TermRep.fDyn al))::Expression) ; _ -> error "Term explosion error."
	g (LETBE_INSET _ _ _ _) xs = case TermRep.fArgs xs of [am,an,ao,ap] -> toDyn ((LETBE_INSET (TermRep.fDyn am) (TermRep.fDyn an) (TermRep.fDyn ao) (TermRep.fDyn ap))::Expression) ; _ -> error "Term explosion error."
	g (LETBE_VAR _ _ _ _) xs = case TermRep.fArgs xs of [aq,ar,as,at] -> toDyn ((LETBE_VAR (TermRep.fDyn aq) (TermRep.fDyn ar) (TermRep.fDyn as) (TermRep.fDyn at))::Expression) ; _ -> error "Term explosion error."
	g (LETBE_PAT _ _ _ _) xs = case TermRep.fArgs xs of [au,av,aw,ax] -> toDyn ((LETBE_PAT (TermRep.fDyn au) (TermRep.fDyn av) (TermRep.fDyn aw) (TermRep.fDyn ax))::Expression) ; _ -> error "Term explosion error."
	g (DEF _ _) xs = case TermRep.fArgs xs of [ay,az] -> toDyn ((DEF (TermRep.fDyn ay) (TermRep.fDyn az))::Expression) ; _ -> error "Term explosion error."
	g (IF_EXPR _) xs = case TermRep.fArgs xs of [aA] -> toDyn ((IF_EXPR (TermRep.fDyn aA))::Expression) ; _ -> error "Term explosion error."
	g (CASE _ _) xs = case TermRep.fArgs xs of [aB,aC] -> toDyn ((CASE (TermRep.fDyn aB) (TermRep.fDyn aC))::Expression) ; _ -> error "Term explosion error."
	g (CASE_OTHER _ _ _) xs = case TermRep.fArgs xs of [aD,aE,aF] -> toDyn ((CASE_OTHER (TermRep.fDyn aD) (TermRep.fDyn aE) (TermRep.fDyn aF))::Expression) ; _ -> error "Term explosion error."
	g (PLUS _) xs = case TermRep.fArgs xs of [aG] -> toDyn ((PLUS (TermRep.fDyn aG))::Expression) ; _ -> error "Term explosion error."
	g (MINUS _) xs = case TermRep.fArgs xs of [aH] -> toDyn ((MINUS (TermRep.fDyn aH))::Expression) ; _ -> error "Term explosion error."
	g (ABS _) xs = case TermRep.fArgs xs of [aI] -> toDyn ((ABS (TermRep.fDyn aI))::Expression) ; _ -> error "Term explosion error."
	g (FLOOR _) xs = case TermRep.fArgs xs of [aJ] -> toDyn ((FLOOR (TermRep.fDyn aJ))::Expression) ; _ -> error "Term explosion error."
	g (NOT _) xs = case TermRep.fArgs xs of [aK] -> toDyn ((NOT (TermRep.fDyn aK))::Expression) ; _ -> error "Term explosion error."
	g (CARD _) xs = case TermRep.fArgs xs of [aL] -> toDyn ((CARD (TermRep.fDyn aL))::Expression) ; _ -> error "Term explosion error."
	g (POWER _) xs = case TermRep.fArgs xs of [aM] -> toDyn ((POWER (TermRep.fDyn aM))::Expression) ; _ -> error "Term explosion error."
	g (DUNION _) xs = case TermRep.fArgs xs of [aN] -> toDyn ((DUNION (TermRep.fDyn aN))::Expression) ; _ -> error "Term explosion error."
	g (DINTER _) xs = case TermRep.fArgs xs of [aO] -> toDyn ((DINTER (TermRep.fDyn aO))::Expression) ; _ -> error "Term explosion error."
	g (HD _) xs = case TermRep.fArgs xs of [aP] -> toDyn ((HD (TermRep.fDyn aP))::Expression) ; _ -> error "Term explosion error."
	g (TL _) xs = case TermRep.fArgs xs of [aQ] -> toDyn ((TL (TermRep.fDyn aQ))::Expression) ; _ -> error "Term explosion error."
	g (LEN _) xs = case TermRep.fArgs xs of [aR] -> toDyn ((LEN (TermRep.fDyn aR))::Expression) ; _ -> error "Term explosion error."
	g (ELEMS _) xs = case TermRep.fArgs xs of [aS] -> toDyn ((ELEMS (TermRep.fDyn aS))::Expression) ; _ -> error "Term explosion error."
	g (INDS _) xs = case TermRep.fArgs xs of [aT] -> toDyn ((INDS (TermRep.fDyn aT))::Expression) ; _ -> error "Term explosion error."
	g (CONC _) xs = case TermRep.fArgs xs of [aU] -> toDyn ((CONC (TermRep.fDyn aU))::Expression) ; _ -> error "Term explosion error."
	g (DOM _) xs = case TermRep.fArgs xs of [aV] -> toDyn ((DOM (TermRep.fDyn aV))::Expression) ; _ -> error "Term explosion error."
	g (RANGE _) xs = case TermRep.fArgs xs of [aW] -> toDyn ((RANGE (TermRep.fDyn aW))::Expression) ; _ -> error "Term explosion error."
	g (MERGE1 _) xs = case TermRep.fArgs xs of [aX] -> toDyn ((MERGE1 (TermRep.fDyn aX))::Expression) ; _ -> error "Term explosion error."
	g (INVERSE _) xs = case TermRep.fArgs xs of [aY] -> toDyn ((INVERSE (TermRep.fDyn aY))::Expression) ; _ -> error "Term explosion error."
	g (ADD _ _) xs = case TermRep.fArgs xs of [aZ,ba] -> toDyn ((ADD (TermRep.fDyn aZ) (TermRep.fDyn ba))::Expression) ; _ -> error "Term explosion error."
	g (SUBTR _ _) xs = case TermRep.fArgs xs of [bb,bc] -> toDyn ((SUBTR (TermRep.fDyn bb) (TermRep.fDyn bc))::Expression) ; _ -> error "Term explosion error."
	g (MULT _ _) xs = case TermRep.fArgs xs of [bd,be] -> toDyn ((MULT (TermRep.fDyn bd) (TermRep.fDyn be))::Expression) ; _ -> error "Term explosion error."
	g (DIVIDE _ _) xs = case TermRep.fArgs xs of [bf,bg] -> toDyn ((DIVIDE (TermRep.fDyn bf) (TermRep.fDyn bg))::Expression) ; _ -> error "Term explosion error."
	g (DIV _ _) xs = case TermRep.fArgs xs of [bh,bi] -> toDyn ((DIV (TermRep.fDyn bh) (TermRep.fDyn bi))::Expression) ; _ -> error "Term explosion error."
	g (REM _ _) xs = case TermRep.fArgs xs of [bj,bk] -> toDyn ((REM (TermRep.fDyn bj) (TermRep.fDyn bk))::Expression) ; _ -> error "Term explosion error."
	g (MOD _ _) xs = case TermRep.fArgs xs of [bl,bm] -> toDyn ((MOD (TermRep.fDyn bl) (TermRep.fDyn bm))::Expression) ; _ -> error "Term explosion error."
	g (LESS _ _) xs = case TermRep.fArgs xs of [bn,bo] -> toDyn ((LESS (TermRep.fDyn bn) (TermRep.fDyn bo))::Expression) ; _ -> error "Term explosion error."
	g (LESS_EQ _ _) xs = case TermRep.fArgs xs of [bp,bq] -> toDyn ((LESS_EQ (TermRep.fDyn bp) (TermRep.fDyn bq))::Expression) ; _ -> error "Term explosion error."
	g (GREAT _ _) xs = case TermRep.fArgs xs of [br,bs] -> toDyn ((GREAT (TermRep.fDyn br) (TermRep.fDyn bs))::Expression) ; _ -> error "Term explosion error."
	g (GREAT_EQ _ _) xs = case TermRep.fArgs xs of [bt,bu] -> toDyn ((GREAT_EQ (TermRep.fDyn bt) (TermRep.fDyn bu))::Expression) ; _ -> error "Term explosion error."
	g (EQUAL _ _) xs = case TermRep.fArgs xs of [bv,bw] -> toDyn ((EQUAL (TermRep.fDyn bv) (TermRep.fDyn bw))::Expression) ; _ -> error "Term explosion error."
	g (NEQ _ _) xs = case TermRep.fArgs xs of [bx,by] -> toDyn ((NEQ (TermRep.fDyn bx) (TermRep.fDyn by))::Expression) ; _ -> error "Term explosion error."
	g (OR _ _) xs = case TermRep.fArgs xs of [bz,bA] -> toDyn ((OR (TermRep.fDyn bz) (TermRep.fDyn bA))::Expression) ; _ -> error "Term explosion error."
	g (AND _ _) xs = case TermRep.fArgs xs of [bB,bC] -> toDyn ((AND (TermRep.fDyn bB) (TermRep.fDyn bC))::Expression) ; _ -> error "Term explosion error."
	g (IMPLY _ _) xs = case TermRep.fArgs xs of [bD,bE] -> toDyn ((IMPLY (TermRep.fDyn bD) (TermRep.fDyn bE))::Expression) ; _ -> error "Term explosion error."
	g (EQUIV _ _) xs = case TermRep.fArgs xs of [bF,bG] -> toDyn ((EQUIV (TermRep.fDyn bF) (TermRep.fDyn bG))::Expression) ; _ -> error "Term explosion error."
	g (IN_SET _ _) xs = case TermRep.fArgs xs of [bH,bI] -> toDyn ((IN_SET (TermRep.fDyn bH) (TermRep.fDyn bI))::Expression) ; _ -> error "Term explosion error."
	g (NOT_IN_SET _ _) xs = case TermRep.fArgs xs of [bJ,bK] -> toDyn ((NOT_IN_SET (TermRep.fDyn bJ) (TermRep.fDyn bK))::Expression) ; _ -> error "Term explosion error."
	g (SUBSET _ _) xs = case TermRep.fArgs xs of [bL,bM] -> toDyn ((SUBSET (TermRep.fDyn bL) (TermRep.fDyn bM))::Expression) ; _ -> error "Term explosion error."
	g (PSUBSET _ _) xs = case TermRep.fArgs xs of [bN,bO] -> toDyn ((PSUBSET (TermRep.fDyn bN) (TermRep.fDyn bO))::Expression) ; _ -> error "Term explosion error."
	g (UNION _ _) xs = case TermRep.fArgs xs of [bP,bQ] -> toDyn ((UNION (TermRep.fDyn bP) (TermRep.fDyn bQ))::Expression) ; _ -> error "Term explosion error."
	g (MERGE2 _ _) xs = case TermRep.fArgs xs of [bR,bS] -> toDyn ((MERGE2 (TermRep.fDyn bR) (TermRep.fDyn bS))::Expression) ; _ -> error "Term explosion error."
	g (SET_DIFF _ _) xs = case TermRep.fArgs xs of [bT,bU] -> toDyn ((SET_DIFF (TermRep.fDyn bT) (TermRep.fDyn bU))::Expression) ; _ -> error "Term explosion error."
	g (INTER _ _) xs = case TermRep.fArgs xs of [bV,bW] -> toDyn ((INTER (TermRep.fDyn bV) (TermRep.fDyn bW))::Expression) ; _ -> error "Term explosion error."
	g (CONCAT _ _) xs = case TermRep.fArgs xs of [bX,bY] -> toDyn ((CONCAT (TermRep.fDyn bX) (TermRep.fDyn bY))::Expression) ; _ -> error "Term explosion error."
	g (MODIFY _ _) xs = case TermRep.fArgs xs of [bZ,ca] -> toDyn ((MODIFY (TermRep.fDyn bZ) (TermRep.fDyn ca))::Expression) ; _ -> error "Term explosion error."
	g (MUNION _ _) xs = case TermRep.fArgs xs of [cb,cc] -> toDyn ((MUNION (TermRep.fDyn cb) (TermRep.fDyn cc))::Expression) ; _ -> error "Term explosion error."
	g (DOM_RESTR_TO _ _) xs = case TermRep.fArgs xs of [cd,ce] -> toDyn ((DOM_RESTR_TO (TermRep.fDyn cd) (TermRep.fDyn ce))::Expression) ; _ -> error "Term explosion error."
	g (DOM_RESTR_BY _ _) xs = case TermRep.fArgs xs of [cf,cg] -> toDyn ((DOM_RESTR_BY (TermRep.fDyn cf) (TermRep.fDyn cg))::Expression) ; _ -> error "Term explosion error."
	g (RNG_RESTR_TO _ _) xs = case TermRep.fArgs xs of [ch,ci] -> toDyn ((RNG_RESTR_TO (TermRep.fDyn ch) (TermRep.fDyn ci))::Expression) ; _ -> error "Term explosion error."
	g (RNG_RESTR_BY _ _) xs = case TermRep.fArgs xs of [cj,ck] -> toDyn ((RNG_RESTR_BY (TermRep.fDyn cj) (TermRep.fDyn ck))::Expression) ; _ -> error "Term explosion error."
	g (COMP _ _) xs = case TermRep.fArgs xs of [cl,cm] -> toDyn ((COMP (TermRep.fDyn cl) (TermRep.fDyn cm))::Expression) ; _ -> error "Term explosion error."
	g (ITERATE _ _) xs = case TermRep.fArgs xs of [cn,co] -> toDyn ((ITERATE (TermRep.fDyn cn) (TermRep.fDyn co))::Expression) ; _ -> error "Term explosion error."
	g (FORALL _ _) xs = case TermRep.fArgs xs of [cp,cq] -> toDyn ((FORALL (TermRep.fDyn cp) (TermRep.fDyn cq))::Expression) ; _ -> error "Term explosion error."
	g (EXISTS _ _) xs = case TermRep.fArgs xs of [cr,cs] -> toDyn ((EXISTS (TermRep.fDyn cr) (TermRep.fDyn cs))::Expression) ; _ -> error "Term explosion error."
	g (EXISTS1 _ _) xs = case TermRep.fArgs xs of [ct,cu] -> toDyn ((EXISTS1 (TermRep.fDyn ct) (TermRep.fDyn cu))::Expression) ; _ -> error "Term explosion error."
	g (IOTA _ _) xs = case TermRep.fArgs xs of [cv,cw] -> toDyn ((IOTA (TermRep.fDyn cv) (TermRep.fDyn cw))::Expression) ; _ -> error "Term explosion error."
	g EMPTY_SET xs = case TermRep.fArgs xs of [] -> toDyn ((EMPTY_SET)::Expression) ; _ -> error "Term explosion error."
	g (SET _) xs = case TermRep.fArgs xs of [cx] -> toDyn ((SET (TermRep.fDyn cx))::Expression) ; _ -> error "Term explosion error."
	g (SET2 _ _) xs = case TermRep.fArgs xs of [cy,cz] -> toDyn ((SET2 (TermRep.fDyn cy) (TermRep.fDyn cz))::Expression) ; _ -> error "Term explosion error."
	g (SET_ENUM _ _ _) xs = case TermRep.fArgs xs of [cA,cB,cC] -> toDyn ((SET_ENUM (TermRep.fDyn cA) (TermRep.fDyn cB) (TermRep.fDyn cC))::Expression) ; _ -> error "Term explosion error."
	g (COMPR_SET _ _) xs = case TermRep.fArgs xs of [cD,cE] -> toDyn ((COMPR_SET (TermRep.fDyn cD) (TermRep.fDyn cE))::Expression) ; _ -> error "Term explosion error."
	g (COMPR_SET_COND _ _ _) xs = case TermRep.fArgs xs of [cF,cG,cH] -> toDyn ((COMPR_SET_COND (TermRep.fDyn cF) (TermRep.fDyn cG) (TermRep.fDyn cH))::Expression) ; _ -> error "Term explosion error."
	g (RANGE_SET _ _) xs = case TermRep.fArgs xs of [cI,cJ] -> toDyn ((RANGE_SET (TermRep.fDyn cI) (TermRep.fDyn cJ))::Expression) ; _ -> error "Term explosion error."
	g EMPTY_SEQ xs = case TermRep.fArgs xs of [] -> toDyn ((EMPTY_SEQ)::Expression) ; _ -> error "Term explosion error."
	g (SEQ _) xs = case TermRep.fArgs xs of [cK] -> toDyn ((SEQ (TermRep.fDyn cK))::Expression) ; _ -> error "Term explosion error."
	g (COMPR_SEQ _ _) xs = case TermRep.fArgs xs of [cL,cM] -> toDyn ((COMPR_SEQ (TermRep.fDyn cL) (TermRep.fDyn cM))::Expression) ; _ -> error "Term explosion error."
	g (COMPR_SEQ_COND _ _ _) xs = case TermRep.fArgs xs of [cN,cO,cP] -> toDyn ((COMPR_SEQ_COND (TermRep.fDyn cN) (TermRep.fDyn cO) (TermRep.fDyn cP))::Expression) ; _ -> error "Term explosion error."
	g (SUBSEQ _ _ _) xs = case TermRep.fArgs xs of [cQ,cR,cS] -> toDyn ((SUBSEQ (TermRep.fDyn cQ) (TermRep.fDyn cR) (TermRep.fDyn cS))::Expression) ; _ -> error "Term explosion error."
	g EMPTY_MAP xs = case TermRep.fArgs xs of [] -> toDyn ((EMPTY_MAP)::Expression) ; _ -> error "Term explosion error."
	g (MAP _) xs = case TermRep.fArgs xs of [cT] -> toDyn ((MAP (TermRep.fDyn cT))::Expression) ; _ -> error "Term explosion error."
	g (COMPR_MAP _ _ _) xs = case TermRep.fArgs xs of [cU,cV,cW] -> toDyn ((COMPR_MAP (TermRep.fDyn cU) (TermRep.fDyn cV) (TermRep.fDyn cW))::Expression) ; _ -> error "Term explosion error."
	g (COMPR_MAP_COND _ _ _ _) xs = case TermRep.fArgs xs of [cX,cY,cZ,da] -> toDyn ((COMPR_MAP_COND (TermRep.fDyn cX) (TermRep.fDyn cY) (TermRep.fDyn cZ) (TermRep.fDyn da))::Expression) ; _ -> error "Term explosion error."
	g (TUPLE _) xs = case TermRep.fArgs xs of [db] -> toDyn ((TUPLE (TermRep.fDyn db))::Expression) ; _ -> error "Term explosion error."
	g (RECORD_E _) xs = case TermRep.fArgs xs of [dc] -> toDyn ((RECORD_E (TermRep.fDyn dc))::Expression) ; _ -> error "Term explosion error."
	g (RECORD_S _ _) xs = case TermRep.fArgs xs of [dd,de] -> toDyn ((RECORD_S (TermRep.fDyn dd) (TermRep.fDyn de))::Expression) ; _ -> error "Term explosion error."
	g (MU _ _) xs = case TermRep.fArgs xs of [df,dg] -> toDyn ((MU (TermRep.fDyn df) (TermRep.fDyn dg))::Expression) ; _ -> error "Term explosion error."
	g (APPLY0 _) xs = case TermRep.fArgs xs of [dh] -> toDyn ((APPLY0 (TermRep.fDyn dh))::Expression) ; _ -> error "Term explosion error."
	g (APPLY1 _ _) xs = case TermRep.fArgs xs of [di,dj] -> toDyn ((APPLY1 (TermRep.fDyn di) (TermRep.fDyn dj))::Expression) ; _ -> error "Term explosion error."
	g (APPLYN _ _ _) xs = case TermRep.fArgs xs of [dk,dl,dm] -> toDyn ((APPLYN (TermRep.fDyn dk) (TermRep.fDyn dl) (TermRep.fDyn dm))::Expression) ; _ -> error "Term explosion error."
	g (FIELD_SEL _ _) xs = case TermRep.fArgs xs of [dn,do1] -> toDyn ((FIELD_SEL (TermRep.fDyn dn) (TermRep.fDyn do1))::Expression) ; _ -> error "Term explosion error."
	g (TUPLE_SEL _ _) xs = case TermRep.fArgs xs of [dp,dq] -> toDyn ((TUPLE_SEL (TermRep.fDyn dp) (TermRep.fDyn dq))::Expression) ; _ -> error "Term explosion error."
	g (FUNCT_TYPE_INST _ _) xs = case TermRep.fArgs xs of [dr,ds] -> toDyn ((FUNCT_TYPE_INST (TermRep.fDyn dr) (TermRep.fDyn ds))::Expression) ; _ -> error "Term explosion error."
	g (LAMBDA _ _) xs = case TermRep.fArgs xs of [dt,du] -> toDyn ((LAMBDA (TermRep.fDyn dt) (TermRep.fDyn du))::Expression) ; _ -> error "Term explosion error."
	g (IS_IDENT _ _) xs = case TermRep.fArgs xs of [dv,dw] -> toDyn ((IS_IDENT (TermRep.fDyn dv) (TermRep.fDyn dw))::Expression) ; _ -> error "Term explosion error."
	g (IDENT _) xs = case TermRep.fArgs xs of [dx] -> toDyn ((IDENT (TermRep.fDyn dx))::Expression) ; _ -> error "Term explosion error."
	g (OLD_NAME _) xs = case TermRep.fArgs xs of [dy] -> toDyn ((OLD_NAME (TermRep.fDyn dy))::Expression) ; _ -> error "Term explosion error."
	g (SYMB_LIT _) xs = case TermRep.fArgs xs of [dz] -> toDyn ((SYMB_LIT (TermRep.fDyn dz))::Expression) ; _ -> error "Term explosion error."

_tc_ExpressionTc = mkTyCon "Expression"
instance Typeable Expression where
    typeOf x = mkAppTy _tc_ExpressionTc [ ]

instance Term Symbolic_literal where
    explode (x::Symbolic_literal) = TermRep (toDyn x, f x, g x) where
	f (LIT_NUM aa) = [explode aa]
	f (NUMERAL ab) = [explode ab]
	f TRUE = []
	f FALSE = []
	f NIL = []
	f (LIT_CHAR ac) = [explode ac]
	f (LIT_STR ad) = [explode ad]
	f (LIT_QUOTE ae) = [explode ae]
	g (LIT_NUM _) xs = case TermRep.fArgs xs of [aa] -> toDyn ((LIT_NUM (TermRep.fDyn aa))::Symbolic_literal) ; _ -> error "Term explosion error."
	g (NUMERAL _) xs = case TermRep.fArgs xs of [ab] -> toDyn ((NUMERAL (TermRep.fDyn ab))::Symbolic_literal) ; _ -> error "Term explosion error."
	g TRUE xs = case TermRep.fArgs xs of [] -> toDyn ((TRUE)::Symbolic_literal) ; _ -> error "Term explosion error."
	g FALSE xs = case TermRep.fArgs xs of [] -> toDyn ((FALSE)::Symbolic_literal) ; _ -> error "Term explosion error."
	g NIL xs = case TermRep.fArgs xs of [] -> toDyn ((NIL)::Symbolic_literal) ; _ -> error "Term explosion error."
	g (LIT_CHAR _) xs = case TermRep.fArgs xs of [ac] -> toDyn ((LIT_CHAR (TermRep.fDyn ac))::Symbolic_literal) ; _ -> error "Term explosion error."
	g (LIT_STR _) xs = case TermRep.fArgs xs of [ad] -> toDyn ((LIT_STR (TermRep.fDyn ad))::Symbolic_literal) ; _ -> error "Term explosion error."
	g (LIT_QUOTE _) xs = case TermRep.fArgs xs of [ae] -> toDyn ((LIT_QUOTE (TermRep.fDyn ae))::Symbolic_literal) ; _ -> error "Term explosion error."

_tc_Symbolic_literalTc = mkTyCon "Symbolic_literal"
instance Typeable Symbolic_literal where
    typeOf x = mkAppTy _tc_Symbolic_literalTc [ ]

instance Term Patternbind_expr_list where
    explode (x::Patternbind_expr_list) = TermRep (toDyn x, f x, g x) where
	f (PATT_BIND_EXPR_S aa ab) = [explode aa,explode ab]
	f (PATT_BIND_EXPR_L ac ad ae) = [explode ac,explode ad,explode ae]
	g (PATT_BIND_EXPR_S _ _) xs = case TermRep.fArgs xs of [aa,ab] -> toDyn ((PATT_BIND_EXPR_S (TermRep.fDyn aa) (TermRep.fDyn ab))::Patternbind_expr_list) ; _ -> error "Term explosion error."
	g (PATT_BIND_EXPR_L _ _ _) xs = case TermRep.fArgs xs of [ac,ad,ae] -> toDyn ((PATT_BIND_EXPR_L (TermRep.fDyn ac) (TermRep.fDyn ad) (TermRep.fDyn ae))::Patternbind_expr_list) ; _ -> error "Term explosion error."

_tc_Patternbind_expr_listTc = mkTyCon "Patternbind_expr_list"
instance Typeable Patternbind_expr_list where
    typeOf x = mkAppTy _tc_Patternbind_expr_listTc [ ]

instance Term Local_definition_list where
    explode (x::Local_definition_list) = TermRep (toDyn x, f x, g x) where
	f (LOCAL_DEF_S aa) = [explode aa]
	f (LOCAL_DEF_L ab ac) = [explode ab,explode ac]
	g (LOCAL_DEF_S _) xs = case TermRep.fArgs xs of [aa] -> toDyn ((LOCAL_DEF_S (TermRep.fDyn aa))::Local_definition_list) ; _ -> error "Term explosion error."
	g (LOCAL_DEF_L _ _) xs = case TermRep.fArgs xs of [ab,ac] -> toDyn ((LOCAL_DEF_L (TermRep.fDyn ab) (TermRep.fDyn ac))::Local_definition_list) ; _ -> error "Term explosion error."

_tc_Local_definition_listTc = mkTyCon "Local_definition_list"
instance Typeable Local_definition_list where
    typeOf x = mkAppTy _tc_Local_definition_listTc [ ]

instance Term If_expression where
    explode (x::If_expression) = TermRep (toDyn x, f x, g x) where
	f (IF_THEN_ELSE aa ab ac) = [explode aa,explode ab,explode ac]
	f (IF_THEN_ELSEIF ad ae af ag) = [explode ad,explode ae,explode af,explode ag]
	g (IF_THEN_ELSE _ _ _) xs = case TermRep.fArgs xs of [aa,ab,ac] -> toDyn ((IF_THEN_ELSE (TermRep.fDyn aa) (TermRep.fDyn ab) (TermRep.fDyn ac))::If_expression) ; _ -> error "Term explosion error."
	g (IF_THEN_ELSEIF _ _ _ _) xs = case TermRep.fArgs xs of [ad,ae,af,ag] -> toDyn ((IF_THEN_ELSEIF (TermRep.fDyn ad) (TermRep.fDyn ae) (TermRep.fDyn af) (TermRep.fDyn ag))::If_expression) ; _ -> error "Term explosion error."

_tc_If_expressionTc = mkTyCon "If_expression"
instance Typeable If_expression where
    typeOf x = mkAppTy _tc_If_expressionTc [ ]

instance Term Elseif_expression where
    explode (x::Elseif_expression) = TermRep (toDyn x, f x, g x) where
	f (ELSEIF aa ab) = [explode aa,explode ab]
	f (EXP_ELSEIF ac ad ae) = [explode ac,explode ad,explode ae]
	g (ELSEIF _ _) xs = case TermRep.fArgs xs of [aa,ab] -> toDyn ((ELSEIF (TermRep.fDyn aa) (TermRep.fDyn ab))::Elseif_expression) ; _ -> error "Term explosion error."
	g (EXP_ELSEIF _ _ _) xs = case TermRep.fArgs xs of [ac,ad,ae] -> toDyn ((EXP_ELSEIF (TermRep.fDyn ac) (TermRep.fDyn ad) (TermRep.fDyn ae))::Elseif_expression) ; _ -> error "Term explosion error."

_tc_Elseif_expressionTc = mkTyCon "Elseif_expression"
instance Typeable Elseif_expression where
    typeOf x = mkAppTy _tc_Elseif_expressionTc [ ]

instance Term Cases_alternative_list where
    explode (x::Cases_alternative_list) = TermRep (toDyn x, f x, g x) where
	f (CASE_ALT_S aa ab) = [explode aa,explode ab]
	f (CASE_ALT_L ac ad ae) = [explode ac,explode ad,explode ae]
	g (CASE_ALT_S _ _) xs = case TermRep.fArgs xs of [aa,ab] -> toDyn ((CASE_ALT_S (TermRep.fDyn aa) (TermRep.fDyn ab))::Cases_alternative_list) ; _ -> error "Term explosion error."
	g (CASE_ALT_L _ _ _) xs = case TermRep.fArgs xs of [ac,ad,ae] -> toDyn ((CASE_ALT_L (TermRep.fDyn ac) (TermRep.fDyn ad) (TermRep.fDyn ae))::Cases_alternative_list) ; _ -> error "Term explosion error."

_tc_Cases_alternative_listTc = mkTyCon "Cases_alternative_list"
instance Typeable Cases_alternative_list where
    typeOf x = mkAppTy _tc_Cases_alternative_listTc [ ]

instance Term Name_list where
    explode (x::Name_list) = TermRep (toDyn x, f x, g x) where
	f (NAME_S aa) = [explode aa]
	f (NAME_L ab ac) = [explode ab,explode ac]
	g (NAME_S _) xs = case TermRep.fArgs xs of [aa] -> toDyn ((NAME_S (TermRep.fDyn aa))::Name_list) ; _ -> error "Term explosion error."
	g (NAME_L _ _) xs = case TermRep.fArgs xs of [ab,ac] -> toDyn ((NAME_L (TermRep.fDyn ab) (TermRep.fDyn ac))::Name_list) ; _ -> error "Term explosion error."

_tc_Name_listTc = mkTyCon "Name_list"
instance Typeable Name_list where
    typeOf x = mkAppTy _tc_Name_listTc [ ]

instance Term Name where
    explode (x::Name) = TermRep (toDyn x, f x, g x) where
	f (IDENTIFIER aa) = [explode aa]
	f (MK_ID ab) = [explode ab]
	f (IS_ID ac) = [explode ac]
	g (IDENTIFIER _) xs = case TermRep.fArgs xs of [aa] -> toDyn ((IDENTIFIER (TermRep.fDyn aa))::Name) ; _ -> error "Term explosion error."
	g (MK_ID _) xs = case TermRep.fArgs xs of [ab] -> toDyn ((MK_ID (TermRep.fDyn ab))::Name) ; _ -> error "Term explosion error."
	g (IS_ID _) xs = case TermRep.fArgs xs of [ac] -> toDyn ((IS_ID (TermRep.fDyn ac))::Name) ; _ -> error "Term explosion error."

_tc_NameTc = mkTyCon "Name"
instance Typeable Name where
    typeOf x = mkAppTy _tc_NameTc [ ]

instance Term Map_enumeration_list where
    explode (x::Map_enumeration_list) = TermRep (toDyn x, f x, g x) where
	f (MAP_ENUM_S aa ab) = [explode aa,explode ab]
	f (MAP_ENUM_L ac ad ae) = [explode ac,explode ad,explode ae]
	g (MAP_ENUM_S _ _) xs = case TermRep.fArgs xs of [aa,ab] -> toDyn ((MAP_ENUM_S (TermRep.fDyn aa) (TermRep.fDyn ab))::Map_enumeration_list) ; _ -> error "Term explosion error."
	g (MAP_ENUM_L _ _ _) xs = case TermRep.fArgs xs of [ac,ad,ae] -> toDyn ((MAP_ENUM_L (TermRep.fDyn ac) (TermRep.fDyn ad) (TermRep.fDyn ae))::Map_enumeration_list) ; _ -> error "Term explosion error."

_tc_Map_enumeration_listTc = mkTyCon "Map_enumeration_list"
instance Typeable Map_enumeration_list where
    typeOf x = mkAppTy _tc_Map_enumeration_listTc [ ]

instance Term Record_modification_list where
    explode (x::Record_modification_list) = TermRep (toDyn x, f x, g x) where
	f (RECORD_MOD_S aa ab) = [explode aa,explode ab]
	f (RECORD_MOD_L ac ad ae) = [explode ac,explode ad,explode ae]
	g (RECORD_MOD_S _ _) xs = case TermRep.fArgs xs of [aa,ab] -> toDyn ((RECORD_MOD_S (TermRep.fDyn aa) (TermRep.fDyn ab))::Record_modification_list) ; _ -> error "Term explosion error."
	g (RECORD_MOD_L _ _ _) xs = case TermRep.fArgs xs of [ac,ad,ae] -> toDyn ((RECORD_MOD_L (TermRep.fDyn ac) (TermRep.fDyn ad) (TermRep.fDyn ae))::Record_modification_list) ; _ -> error "Term explosion error."

_tc_Record_modification_listTc = mkTyCon "Record_modification_list"
instance Typeable Record_modification_list where
    typeOf x = mkAppTy _tc_Record_modification_listTc [ ]

instance Term State_designator where
    explode (x::State_designator) = TermRep (toDyn x, f x, g x) where
	f (STATE_S aa) = [explode aa]
	f (STATE_L ab ac) = [explode ab,explode ac]
	f (STATE_EXPR_L ad ae) = [explode ad,explode ae]
	g (STATE_S _) xs = case TermRep.fArgs xs of [aa] -> toDyn ((STATE_S (TermRep.fDyn aa))::State_designator) ; _ -> error "Term explosion error."
	g (STATE_L _ _) xs = case TermRep.fArgs xs of [ab,ac] -> toDyn ((STATE_L (TermRep.fDyn ab) (TermRep.fDyn ac))::State_designator) ; _ -> error "Term explosion error."
	g (STATE_EXPR_L _ _) xs = case TermRep.fArgs xs of [ad,ae] -> toDyn ((STATE_EXPR_L (TermRep.fDyn ad) (TermRep.fDyn ae))::State_designator) ; _ -> error "Term explosion error."

_tc_State_designatorTc = mkTyCon "State_designator"
instance Typeable State_designator where
    typeOf x = mkAppTy _tc_State_designatorTc [ ]

instance Term Statement_list where
    explode (x::Statement_list) = TermRep (toDyn x, f x, g x) where
	f (STATEMENT_S aa) = [explode aa]
	f (STATEMENT_L ab ac) = [explode ab,explode ac]
	g (STATEMENT_S _) xs = case TermRep.fArgs xs of [aa] -> toDyn ((STATEMENT_S (TermRep.fDyn aa))::Statement_list) ; _ -> error "Term explosion error."
	g (STATEMENT_L _ _) xs = case TermRep.fArgs xs of [ab,ac] -> toDyn ((STATEMENT_L (TermRep.fDyn ab) (TermRep.fDyn ac))::Statement_list) ; _ -> error "Term explosion error."

_tc_Statement_listTc = mkTyCon "Statement_list"
instance Typeable Statement_list where
    typeOf x = mkAppTy _tc_Statement_listTc [ ]

instance Term Statement where
    explode (x::Statement) = TermRep (toDyn x, f x, g x) where
	f (LET_STAT aa ab) = [explode aa,explode ab]
	f (LET_INSET_STAT ac ad ae) = [explode ac,explode ad,explode ae]
	f (LET_VAR_STAT af ag ah) = [explode af,explode ag,explode ah]
	f (LET_PAT_STAT ai aj ak) = [explode ai,explode aj,explode ak]
	f (LETBE_INSET_STAT al am an ao) = [explode al,explode am,explode an,explode ao]
	f (LETBE_VAR_STAT ap aq ar as) = [explode ap,explode aq,explode ar,explode as]
	f (LETBE_PAT_STAT at au av aw) = [explode at,explode au,explode av,explode aw]
	f (DEF_STAT ax ay) = [explode ax,explode ay]
	f (MAYBE_DCL_STAT az aA) = [explode az,explode aA]
	f (CALL_STAT aB) = [explode aB]
	f SKIP = []
	g (LET_STAT _ _) xs = case TermRep.fArgs xs of [aa,ab] -> toDyn ((LET_STAT (TermRep.fDyn aa) (TermRep.fDyn ab))::Statement) ; _ -> error "Term explosion error."
	g (LET_INSET_STAT _ _ _) xs = case TermRep.fArgs xs of [ac,ad,ae] -> toDyn ((LET_INSET_STAT (TermRep.fDyn ac) (TermRep.fDyn ad) (TermRep.fDyn ae))::Statement) ; _ -> error "Term explosion error."
	g (LET_VAR_STAT _ _ _) xs = case TermRep.fArgs xs of [af,ag,ah] -> toDyn ((LET_VAR_STAT (TermRep.fDyn af) (TermRep.fDyn ag) (TermRep.fDyn ah))::Statement) ; _ -> error "Term explosion error."
	g (LET_PAT_STAT _ _ _) xs = case TermRep.fArgs xs of [ai,aj,ak] -> toDyn ((LET_PAT_STAT (TermRep.fDyn ai) (TermRep.fDyn aj) (TermRep.fDyn ak))::Statement) ; _ -> error "Term explosion error."
	g (LETBE_INSET_STAT _ _ _ _) xs = case TermRep.fArgs xs of [al,am,an,ao] -> toDyn ((LETBE_INSET_STAT (TermRep.fDyn al) (TermRep.fDyn am) (TermRep.fDyn an) (TermRep.fDyn ao))::Statement) ; _ -> error "Term explosion error."
	g (LETBE_VAR_STAT _ _ _ _) xs = case TermRep.fArgs xs of [ap,aq,ar,as] -> toDyn ((LETBE_VAR_STAT (TermRep.fDyn ap) (TermRep.fDyn aq) (TermRep.fDyn ar) (TermRep.fDyn as))::Statement) ; _ -> error "Term explosion error."
	g (LETBE_PAT_STAT _ _ _ _) xs = case TermRep.fArgs xs of [at,au,av,aw] -> toDyn ((LETBE_PAT_STAT (TermRep.fDyn at) (TermRep.fDyn au) (TermRep.fDyn av) (TermRep.fDyn aw))::Statement) ; _ -> error "Term explosion error."
	g (DEF_STAT _ _) xs = case TermRep.fArgs xs of [ax,ay] -> toDyn ((DEF_STAT (TermRep.fDyn ax) (TermRep.fDyn ay))::Statement) ; _ -> error "Term explosion error."
	g (MAYBE_DCL_STAT _ _) xs = case TermRep.fArgs xs of [az,aA] -> toDyn ((MAYBE_DCL_STAT (TermRep.fDyn az) (TermRep.fDyn aA))::Statement) ; _ -> error "Term explosion error."
	g (CALL_STAT _) xs = case TermRep.fArgs xs of [aB] -> toDyn ((CALL_STAT (TermRep.fDyn aB))::Statement) ; _ -> error "Term explosion error."
	g SKIP xs = case TermRep.fArgs xs of [] -> toDyn ((SKIP)::Statement) ; _ -> error "Term explosion error."

_tc_StatementTc = mkTyCon "Statement"
instance Typeable Statement where
    typeOf x = mkAppTy _tc_StatementTc [ ]

instance Term Call_statement where
    explode (x::Call_statement) = TermRep (toDyn x, f x, g x) where
	f (CALL_ID_STAT aa) = [explode aa]
	f (CALL_EXPR_STAT ab ac) = [explode ab,explode ac]
	f (CALL_STATE_STAT ad ae) = [explode ad,explode ae]
	f (CALL_EXPR_STATE_STAT af ag ah) = [explode af,explode ag,explode ah]
	g (CALL_ID_STAT _) xs = case TermRep.fArgs xs of [aa] -> toDyn ((CALL_ID_STAT (TermRep.fDyn aa))::Call_statement) ; _ -> error "Term explosion error."
	g (CALL_EXPR_STAT _ _) xs = case TermRep.fArgs xs of [ab,ac] -> toDyn ((CALL_EXPR_STAT (TermRep.fDyn ab) (TermRep.fDyn ac))::Call_statement) ; _ -> error "Term explosion error."
	g (CALL_STATE_STAT _ _) xs = case TermRep.fArgs xs of [ad,ae] -> toDyn ((CALL_STATE_STAT (TermRep.fDyn ad) (TermRep.fDyn ae))::Call_statement) ; _ -> error "Term explosion error."
	g (CALL_EXPR_STATE_STAT _ _ _) xs = case TermRep.fArgs xs of [af,ag,ah] -> toDyn ((CALL_EXPR_STATE_STAT (TermRep.fDyn af) (TermRep.fDyn ag) (TermRep.fDyn ah))::Call_statement) ; _ -> error "Term explosion error."

_tc_Call_statementTc = mkTyCon "Call_statement"
instance Typeable Call_statement where
    typeOf x = mkAppTy _tc_Call_statementTc [ ]

instance Term Equals_definition_list where
    explode (x::Equals_definition_list) = TermRep (toDyn x, f x, g x) where
	f (EQUALS_DEF_S aa ab) = [explode aa,explode ab]
	f (EQUALS_DEF_L ac ad ae) = [explode ac,explode ad,explode ae]
	g (EQUALS_DEF_S _ _) xs = case TermRep.fArgs xs of [aa,ab] -> toDyn ((EQUALS_DEF_S (TermRep.fDyn aa) (TermRep.fDyn ab))::Equals_definition_list) ; _ -> error "Term explosion error."
	g (EQUALS_DEF_L _ _ _) xs = case TermRep.fArgs xs of [ac,ad,ae] -> toDyn ((EQUALS_DEF_L (TermRep.fDyn ac) (TermRep.fDyn ad) (TermRep.fDyn ae))::Equals_definition_list) ; _ -> error "Term explosion error."

_tc_Equals_definition_listTc = mkTyCon "Equals_definition_list"
instance Typeable Equals_definition_list where
    typeOf x = mkAppTy _tc_Equals_definition_listTc [ ]

instance Term Maybe_dcl_statement_list where
    explode (x::Maybe_dcl_statement_list) = TermRep (toDyn x, f x, g x) where
	f MAYBE_DCL_STAT_E = []
	f (MAYBE_DCL_STAT_S aa ab ac) = [explode aa,explode ab,explode ac]
	f (MAYBE_DCL_STAT_L ad ae af ag) = [explode ad,explode ae,explode af,explode ag]
	g MAYBE_DCL_STAT_E xs = case TermRep.fArgs xs of [] -> toDyn ((MAYBE_DCL_STAT_E)::Maybe_dcl_statement_list) ; _ -> error "Term explosion error."
	g (MAYBE_DCL_STAT_S _ _ _) xs = case TermRep.fArgs xs of [aa,ab,ac] -> toDyn ((MAYBE_DCL_STAT_S (TermRep.fDyn aa) (TermRep.fDyn ab) (TermRep.fDyn ac))::Maybe_dcl_statement_list) ; _ -> error "Term explosion error."
	g (MAYBE_DCL_STAT_L _ _ _ _) xs = case TermRep.fArgs xs of [ad,ae,af,ag] -> toDyn ((MAYBE_DCL_STAT_L (TermRep.fDyn ad) (TermRep.fDyn ae) (TermRep.fDyn af) (TermRep.fDyn ag))::Maybe_dcl_statement_list) ; _ -> error "Term explosion error."

_tc_Maybe_dcl_statement_listTc = mkTyCon "Maybe_dcl_statement_list"
instance Typeable Maybe_dcl_statement_list where
    typeOf x = mkAppTy _tc_Maybe_dcl_statement_listTc [ ]

instance Term Pattern_list where
    explode (x::Pattern_list) = TermRep (toDyn x, f x, g x) where
	f (PATTERN_S aa) = [explode aa]
	f (PATTERN_L ab ac) = [explode ab,explode ac]
	g (PATTERN_S _) xs = case TermRep.fArgs xs of [aa] -> toDyn ((PATTERN_S (TermRep.fDyn aa))::Pattern_list) ; _ -> error "Term explosion error."
	g (PATTERN_L _ _) xs = case TermRep.fArgs xs of [ab,ac] -> toDyn ((PATTERN_L (TermRep.fDyn ab) (TermRep.fDyn ac))::Pattern_list) ; _ -> error "Term explosion error."

_tc_Pattern_listTc = mkTyCon "Pattern_list"
instance Typeable Pattern_list where
    typeOf x = mkAppTy _tc_Pattern_listTc [ ]

instance Term Pattern where
    explode (x::Pattern) = TermRep (toDyn x, f x, g x) where
	f (PAT_NAME aa) = [explode aa]
	f (PAT_PAT ab) = [explode ab]
	g (PAT_NAME _) xs = case TermRep.fArgs xs of [aa] -> toDyn ((PAT_NAME (TermRep.fDyn aa))::Pattern) ; _ -> error "Term explosion error."
	g (PAT_PAT _) xs = case TermRep.fArgs xs of [ab] -> toDyn ((PAT_PAT (TermRep.fDyn ab))::Pattern) ; _ -> error "Term explosion error."

_tc_PatternTc = mkTyCon "Pattern"
instance Typeable Pattern where
    typeOf x = mkAppTy _tc_PatternTc [ ]

instance Term Pattern2 where
    explode (x::Pattern2) = TermRep (toDyn x, f x, g x) where
	f IDENT_PAT = []
	f (BRACK_PAT aa) = [explode aa]
	f (SYMB_LIT_PAT ab) = [explode ab]
	f (SET_ENUM_PAT ac) = [explode ac]
	f (SET_UNION_PAT ad ae) = [explode ad,explode ae]
	f (SEQ_ENUM_PAT af) = [explode af]
	f (SEQ_CONC_PAT ag ah) = [explode ag,explode ah]
	f (TUPLE_PAT ai) = [explode ai]
	f (LIST_PAT aj ak) = [explode aj,explode ak]
	g IDENT_PAT xs = case TermRep.fArgs xs of [] -> toDyn ((IDENT_PAT)::Pattern2) ; _ -> error "Term explosion error."
	g (BRACK_PAT _) xs = case TermRep.fArgs xs of [aa] -> toDyn ((BRACK_PAT (TermRep.fDyn aa))::Pattern2) ; _ -> error "Term explosion error."
	g (SYMB_LIT_PAT _) xs = case TermRep.fArgs xs of [ab] -> toDyn ((SYMB_LIT_PAT (TermRep.fDyn ab))::Pattern2) ; _ -> error "Term explosion error."
	g (SET_ENUM_PAT _) xs = case TermRep.fArgs xs of [ac] -> toDyn ((SET_ENUM_PAT (TermRep.fDyn ac))::Pattern2) ; _ -> error "Term explosion error."
	g (SET_UNION_PAT _ _) xs = case TermRep.fArgs xs of [ad,ae] -> toDyn ((SET_UNION_PAT (TermRep.fDyn ad) (TermRep.fDyn ae))::Pattern2) ; _ -> error "Term explosion error."
	g (SEQ_ENUM_PAT _) xs = case TermRep.fArgs xs of [af] -> toDyn ((SEQ_ENUM_PAT (TermRep.fDyn af))::Pattern2) ; _ -> error "Term explosion error."
	g (SEQ_CONC_PAT _ _) xs = case TermRep.fArgs xs of [ag,ah] -> toDyn ((SEQ_CONC_PAT (TermRep.fDyn ag) (TermRep.fDyn ah))::Pattern2) ; _ -> error "Term explosion error."
	g (TUPLE_PAT _) xs = case TermRep.fArgs xs of [ai] -> toDyn ((TUPLE_PAT (TermRep.fDyn ai))::Pattern2) ; _ -> error "Term explosion error."
	g (LIST_PAT _ _) xs = case TermRep.fArgs xs of [aj,ak] -> toDyn ((LIST_PAT (TermRep.fDyn aj) (TermRep.fDyn ak))::Pattern2) ; _ -> error "Term explosion error."

_tc_Pattern2Tc = mkTyCon "Pattern2"
instance Typeable Pattern2 where
    typeOf x = mkAppTy _tc_Pattern2Tc [ ]

instance Term Pattern_bind where
    explode (x::Pattern_bind) = TermRep (toDyn x, f x, g x) where
	f (PAT_BIND_PAT aa) = [explode aa]
	f (PAT_BIND_BIND ab) = [explode ab]
	g (PAT_BIND_PAT _) xs = case TermRep.fArgs xs of [aa] -> toDyn ((PAT_BIND_PAT (TermRep.fDyn aa))::Pattern_bind) ; _ -> error "Term explosion error."
	g (PAT_BIND_BIND _) xs = case TermRep.fArgs xs of [ab] -> toDyn ((PAT_BIND_BIND (TermRep.fDyn ab))::Pattern_bind) ; _ -> error "Term explosion error."

_tc_Pattern_bindTc = mkTyCon "Pattern_bind"
instance Typeable Pattern_bind where
    typeOf x = mkAppTy _tc_Pattern_bindTc [ ]

instance Term Bind where
    explode (x::Bind) = TermRep (toDyn x, f x, g x) where
	f (BIND_EXPR aa ab) = [explode aa,explode ab]
	f (BIND_TYPE ac ad) = [explode ac,explode ad]
	g (BIND_EXPR _ _) xs = case TermRep.fArgs xs of [aa,ab] -> toDyn ((BIND_EXPR (TermRep.fDyn aa) (TermRep.fDyn ab))::Bind) ; _ -> error "Term explosion error."
	g (BIND_TYPE _ _) xs = case TermRep.fArgs xs of [ac,ad] -> toDyn ((BIND_TYPE (TermRep.fDyn ac) (TermRep.fDyn ad))::Bind) ; _ -> error "Term explosion error."

_tc_BindTc = mkTyCon "Bind"
instance Typeable Bind where
    typeOf x = mkAppTy _tc_BindTc [ ]

instance Term Bind_list where
    explode (x::Bind_list) = TermRep (toDyn x, f x, g x) where
	f (BIND_S1 aa) = [explode aa]
	f (BIND_S2 ab) = [explode ab]
	f (BIND_L1 ac ad) = [explode ac,explode ad]
	f (BIND_L2 ae af) = [explode ae,explode af]
	g (BIND_S1 _) xs = case TermRep.fArgs xs of [aa] -> toDyn ((BIND_S1 (TermRep.fDyn aa))::Bind_list) ; _ -> error "Term explosion error."
	g (BIND_S2 _) xs = case TermRep.fArgs xs of [ab] -> toDyn ((BIND_S2 (TermRep.fDyn ab))::Bind_list) ; _ -> error "Term explosion error."
	g (BIND_L1 _ _) xs = case TermRep.fArgs xs of [ac,ad] -> toDyn ((BIND_L1 (TermRep.fDyn ac) (TermRep.fDyn ad))::Bind_list) ; _ -> error "Term explosion error."
	g (BIND_L2 _ _) xs = case TermRep.fArgs xs of [ae,af] -> toDyn ((BIND_L2 (TermRep.fDyn ae) (TermRep.fDyn af))::Bind_list) ; _ -> error "Term explosion error."

_tc_Bind_listTc = mkTyCon "Bind_list"
instance Typeable Bind_list where
    typeOf x = mkAppTy _tc_Bind_listTc [ ]

instance Term Multiple_set_bind where
    explode (x::Multiple_set_bind) = TermRep (toDyn x, f x, g x) where
	f (MULT_SET_BIND aa ab) = [explode aa,explode ab]
	g (MULT_SET_BIND _ _) xs = case TermRep.fArgs xs of [aa,ab] -> toDyn ((MULT_SET_BIND (TermRep.fDyn aa) (TermRep.fDyn ab))::Multiple_set_bind) ; _ -> error "Term explosion error."

_tc_Multiple_set_bindTc = mkTyCon "Multiple_set_bind"
instance Typeable Multiple_set_bind where
    typeOf x = mkAppTy _tc_Multiple_set_bindTc [ ]

instance Term Multiple_type_bind where
    explode (x::Multiple_type_bind) = TermRep (toDyn x, f x, g x) where
	f (MULT_TYPE_BIND aa ab) = [explode aa,explode ab]
	g (MULT_TYPE_BIND _ _) xs = case TermRep.fArgs xs of [aa,ab] -> toDyn ((MULT_TYPE_BIND (TermRep.fDyn aa) (TermRep.fDyn ab))::Multiple_type_bind) ; _ -> error "Term explosion error."

_tc_Multiple_type_bindTc = mkTyCon "Multiple_type_bind"
instance Typeable Multiple_type_bind where
    typeOf x = mkAppTy _tc_Multiple_type_bindTc [ ]

instance Term Type_bind_list where
    explode (x::Type_bind_list) = TermRep (toDyn x, f x, g x) where
	f (TYPE_BIND_S aa ab) = [explode aa,explode ab]
	f (TYPE_BIND_L ac ad ae) = [explode ac,explode ad,explode ae]
	g (TYPE_BIND_S _ _) xs = case TermRep.fArgs xs of [aa,ab] -> toDyn ((TYPE_BIND_S (TermRep.fDyn aa) (TermRep.fDyn ab))::Type_bind_list) ; _ -> error "Term explosion error."
	g (TYPE_BIND_L _ _ _) xs = case TermRep.fArgs xs of [ac,ad,ae] -> toDyn ((TYPE_BIND_L (TermRep.fDyn ac) (TermRep.fDyn ad) (TermRep.fDyn ae))::Type_bind_list) ; _ -> error "Term explosion error."

_tc_Type_bind_listTc = mkTyCon "Type_bind_list"
instance Typeable Type_bind_list where
    typeOf x = mkAppTy _tc_Type_bind_listTc [ ]

instance Term Local_definition where
    explode (x::Local_definition) = TermRep (toDyn x, f x, g x) where
	f (L_PAT aa ab) = [explode aa,explode ab]
	f (L_NAME ac ad ae) = [explode ac,explode ad,explode ae]
	f (L_PAT_TYPE af ag ah) = [explode af,explode ag,explode ah]
	f (L_EXPL_FUNC ai aj ak al am an) = [explode ai,explode aj,explode ak,explode al,explode am,explode an]
	f (L_EXPL_FUNC_TYPE ao ap aq ar as at au) = [explode ao,explode ap,explode aq,explode ar,explode as,explode at,explode au]
	f (L_IMPL_FUNC av aw ax ay az aA) = [explode av,explode aw,explode ax,explode ay,explode az,explode aA]
	f (L_IMPL_FUNC_TYPE aB aC aD aE aF aG aH) = [explode aB,explode aC,explode aD,explode aE,explode aF,explode aG,explode aH]
	g (L_PAT _ _) xs = case TermRep.fArgs xs of [aa,ab] -> toDyn ((L_PAT (TermRep.fDyn aa) (TermRep.fDyn ab))::Local_definition) ; _ -> error "Term explosion error."
	g (L_NAME _ _ _) xs = case TermRep.fArgs xs of [ac,ad,ae] -> toDyn ((L_NAME (TermRep.fDyn ac) (TermRep.fDyn ad) (TermRep.fDyn ae))::Local_definition) ; _ -> error "Term explosion error."
	g (L_PAT_TYPE _ _ _) xs = case TermRep.fArgs xs of [af,ag,ah] -> toDyn ((L_PAT_TYPE (TermRep.fDyn af) (TermRep.fDyn ag) (TermRep.fDyn ah))::Local_definition) ; _ -> error "Term explosion error."
	g (L_EXPL_FUNC _ _ _ _ _ _) xs = case TermRep.fArgs xs of [ai,aj,ak,al,am,an] -> toDyn ((L_EXPL_FUNC (TermRep.fDyn ai) (TermRep.fDyn aj) (TermRep.fDyn ak) (TermRep.fDyn al) (TermRep.fDyn am) (TermRep.fDyn an))::Local_definition) ; _ -> error "Term explosion error."
	g (L_EXPL_FUNC_TYPE _ _ _ _ _ _ _) xs = case TermRep.fArgs xs of [ao,ap,aq,ar,as,at,au] -> toDyn ((L_EXPL_FUNC_TYPE (TermRep.fDyn ao) (TermRep.fDyn ap) (TermRep.fDyn aq) (TermRep.fDyn ar) (TermRep.fDyn as) (TermRep.fDyn at) (TermRep.fDyn au))::Local_definition) ; _ -> error "Term explosion error."
	g (L_IMPL_FUNC _ _ _ _ _ _) xs = case TermRep.fArgs xs of [av,aw,ax,ay,az,aA] -> toDyn ((L_IMPL_FUNC (TermRep.fDyn av) (TermRep.fDyn aw) (TermRep.fDyn ax) (TermRep.fDyn ay) (TermRep.fDyn az) (TermRep.fDyn aA))::Local_definition) ; _ -> error "Term explosion error."
	g (L_IMPL_FUNC_TYPE _ _ _ _ _ _ _) xs = case TermRep.fArgs xs of [aB,aC,aD,aE,aF,aG,aH] -> toDyn ((L_IMPL_FUNC_TYPE (TermRep.fDyn aB) (TermRep.fDyn aC) (TermRep.fDyn aD) (TermRep.fDyn aE) (TermRep.fDyn aF) (TermRep.fDyn aG) (TermRep.fDyn aH))::Local_definition) ; _ -> error "Term explosion error."

_tc_Local_definitionTc = mkTyCon "Local_definition"
instance Typeable Local_definition where
    typeOf x = mkAppTy _tc_Local_definitionTc [ ]

--  Imported from other files :-
