{-# OPTIONS -fglasgow-exts #-}

module Pointless.Container where

import Pointless.Functors
import Pointless.Combinators
import Pointless.RecursionPatterns

--gmap :: (FunctorOf f d, FunctorOf g e, C f g p) => d -> p -> d -> e
gmap (_::d) f = cata (_L::d) (inn . pcmap (_L::d) f)

maplist :: (a -> b) -> [a] -> [b]
maplist = gmap (_L::[a])

--pcmap :: (FunctorOf f d, Rep (f a) fa, C f g p, Rep (g a) ga) => d -> p -> fa -> ga
pcmap (_::d) (f::p) = to . (cmap :: (FunctorOf f d, C f g p) => p -> f a -> g a) f . from

class C f g p | f p -> g, g p -> f
    where cmap :: p -> f a -> g a

instance C (Const One :+: (Const a :*: Id)) (Const One :+: (Const b :*: Id)) (a -> b)
    where cmap f = from . (id -|- f >< id) . to

instance C (Const One :+: (Const a :*: (Id :*: Id))) (Const One :+: (Const b :*: (Id :*: Id))) (a->b)
    where cmap f = from . (id -|- f >< (id >< id)) . to

instance C Id Id One
    where cmap _ (Id x) = Id x

instance C (Const One) (Const One) One
    where cmap _ (Const x) = Const x

instance C (Const a) (Const b) (a -> b)
    where cmap f (Const x) = Const (f x)

instance (C f h fh, C g i gi) => C (f :*: g) (h :*: i) (fh,gi)
    where cmap (f,g) (x :*: y) = (cmap f x) :*: (cmap g y)

instance (C f h fh, C g i gi) => C (f :+: g) (h :+: i) (fh,gi)
    where cmap (f,g) (Inl x) = Inl (cmap f x) 
	  cmap (f,g) (Inr x) = Inr (cmap g x) 



