{-# OPTIONS -fglasgow-exts #-}

module Pointless.Examples.Inwards where

import Pointless.Combinators
import Pointless.Functors
import Pointless.Isomorphisms
import Pointless.RecursionPatterns






iszero = (==0)

myuntil :: (a -> Bool) -> [a] -> [a]
myuntil q = hylo (_L::Mu (Const One :+: (Const a :*: (Const [a] :+: Id)))) g h 
    where h = p . out
	  p = id -|- undistr . ((q . fst)?)
	  g = (inn \/ id) . f
	  f = (id -|- snd) . coassocl . (id -|- distr)

myfilter :: (a -> Bool) -> [a] -> [a]
myfilter p = ana (_L::[a]) (out . myuntil p)

myfilter_t :: (a -> Bool) -> [a] -> [a]
myfilter_t q = cata (_L::[a]) g
    where g = (inn \/ id) . f . p
	  p = id -|- undistr . ((q . fst)?)
	  f = (id -|- snd) . coassocl . (id -|- distr)

mydrop :: ([a],Int) -> [a]
mydrop = hylo (_L::Mu ((Const One :+: (Const a :*: (Const [a] :+: Id))) :*: Const Int)) g h
    where h = (d >< id) . (id /\ snd) . (out >< id)
--	  h = ((id -|- id >< (fst -|- id)) >< id) . (d >< id) . (id /\ snd) . (out >< id)
	  d = (id -|- id >< ((fst -|- id >< pred) . ((iszero . snd)?))) . (fst -|- assocr) . distl
--	  d = (fst -|- assocr . (id >< pred)) . distl
--	  p = (((id \/ id) -|- undistr) . ((inl -|- inl) \/ (inr -|- inr)) >< id) . undistl . ((iszero . snd)?)
	  g = (inn \/ id) . f . fst
	  f = (id -|- snd) . coassocl . (id -|- distr)

_mydrop :: ([a],Int) -> [a]
_mydrop ([],   _)   = []
_mydrop (x:xs, 0)   = x:xs
_mydrop (x:xs, n+1) = _mydrop (xs, n)

dropping3 :: [a] -> [a]
dropping3 = ana (_L::[a]) h
    where h = out . _mydrop . (id /\ (3!)) 

dropping3_t :: [a] -> [a]
dropping3_t = (hylo (_L::Mu ((Const One :+: (Const a :*: Id)) :*: Const Int)) g h) . (id /\ (3!)) 
    where h = ((id -|- id >< ((id /\ (3!)) \/ id)) >< id) . (d >< id) . (id /\ snd) . (out >< id)
	  d = (id -|- id >< ((fst -|- id >< pred) . ((iszero . snd)?))) . (fst -|- assocr) . distl
--	  d = (fst -|- assocr . (id >< pred)) . distl
--	  p = (((id \/ id) -|- undistr) . ((inl -|- inl) \/ (inr -|- inr)) >< id) . undistl . ((iszero . snd)?)
	  g = (inn \/ id) . f . (id -|- id >< (id -|- fst)) . d
	  f = (id -|- snd) . coassocl . (id -|- distr)



myuntil_para :: (a -> Bool) -> [a] -> [a]
myuntil_para p = para (_L::[a]) f
    where f = (inn \/ id) . (pmap (_L::[a]) snd -|- fst) . (id -|- snd) . coassocl . (id -|- ((p . fst)?))



tl :: [a] -> [a]
tl []    = []
tl (h:t) = t


	  
pcata (_::d) d f (x::(a,d)) = 
    (hylo (_L::(FunctorOf f d => Mu (Const a :*: f))) f ((id >< d) . (fst /\ id) . (id >< out))) x

dropping ::  Int -> [a] -> [a]
dropping n = ana (_L::[a]) h
    where h = out . mydrop' . (id /\ (n!))

dropping_t :: Int -> [a] -> [a]
dropping_t n = (hylo (_L::Mu ((Const One :+: (Const a :*: Id)) :+: Id)) (inn \/ id) g) . ((n!) /\ id)
    where g = ((id -|- id >< ((n!) /\ id)) . out -|- id) . (snd -|- id >< tl) . distl . (out >< id)

dropping_t_pcata :: Int -> [a] -> [a]
dropping_t_pcata n = (pcata (_L::[a]) d f) . ((n!) /\ id)
    where d = (snd -|- assocr . (swap >< id) . assocl) . distr . (((n!) \/ pred) . (iszero?) >< id)
	  f = (([]!) \/ (cons . snd \/ snd . snd) . ((iszero . fst)?)) . distr

mydrop' :: ([a],Int) -> [a]
mydrop' = hylo (_L::Mu ((Const One :+: (Const a :*: (Id :*: Const [a]))) :*: Const Int)) g h
    where h = ((id -|- id >< (id /\ fst)) >< id) . (d >< id) . (id /\ snd) . (out >< id)
	  g = (inn \/ id) . ((id -|- id >< snd) -|- fst) . coassocl . (fst -|- (fst -|- snd . fst) . ((iszero . snd)?)) . distl
	  d = (fst -|- assocr . (id >< pred)) . distl

