{-# OPTIONS -fglasgow-exts -fallow-overlapping-instances #-}

module Pointless.Observe.Functors where

import Pointless.Combinators
import Pointless.Functors
import Debug.Observe

-- Generic instances of Observable

{-
instance Observable a => Observable (Mu (Const One :+: Const a :*: Id))
    where observer (Mu (Inl (Const x))) = 
	      send "" (do x' <- thunk x
		          return (Mu (Inl (Const x')))
		      )
	  observer (Mu (Inr (Const x :*: Id y))) = 
	      send "" (do x' <- thunk x
		          y' <- thunk y
		          return (Mu (Inr (Const x' :*: Id y')))
		      )
-}

instance (Functor f, FunctorO f) => Observable (Mu f)
    where observer (Mu x) = send "" (do x' <- fmapO thunk x
				        return (Mu x')
				    )

class FunctorO f 
    where fmapO :: (a -> ObserverM b) -> f a -> ObserverM (f b)

instance FunctorO Id
    where fmapO f (Id x) = do x' <- f x
			      return (Id x')

instance Observable a => FunctorO (Const a)
    where fmapO f (Const x) = do x' <- thunk x
				 return (Const x')

instance (FunctorO f, FunctorO g) => FunctorO (f :+: g)
    where fmapO f (Inl x) = do x' <- fmapO f x
			       return (Inl x')
	  fmapO f (Inr x) = do x' <- fmapO f  x
			       return (Inr x')

instance (FunctorO f, FunctorO g) => FunctorO (f :*: g)
    where fmapO f (x :*: y) = do x' <- fmapO f x
				 y' <- fmapO f y
				 return (x' :*: y')

instance (FunctorO g, FunctorO h) => FunctorO (g :@: h)
    where fmapO f (Comp x) = do x' <- fmapO (fmapO f) x
			        return (Comp x')

instance FunctorO []
    where fmapO f l = do l' <- sequence (map f l)
			 return l'

instance Observable One
    where observer _ = _L


