{-# OPTIONS -fglasgow-exts #-}

module Pointless.Observe.RecursionPatterns where

import Pointless.Combinators
import Pointless.Functors
import Pointless.RecursionPatterns
import Debug.Observe

-- Observing Hylomorphisms

hyloO (_::d) g h = cata (_L::FunctorOf f d => Mu f) g . 
		   observe "Recursion Tree" . 
		   ana (_L::FunctorOf f d => Mu f) h

hyloX (_::d) g h = cata (_L::d) g . 
		   observe "Recursion Tree" . 
		   ana (_L::d) h

cataO (_::d) f = hyloO (_L::d) f out

anaO (_::d) f = hyloO (_L::d) inn f

paraO (_::d) f = 
    hyloO (_L :: FunctorOf f d => Mu (f :@: (Id :*: Const d))) 
	 f (pmap (_L::d) (id /\ id) . out)

apoO (_::d) f = 
    hyloO (_L :: FunctorOf f d => Mu (f :@: (Id :+: Const d)))
	 (inn . pmap (_L::d) (id \/ id)) f

accumO (_::d) t f = 
    hyloO (_L :: FunctorOf f d => Mu (f :*: (Const a))) 
	 f ((t /\ snd) . (out >< id))


