module PrettyPrint.Tables.Data_Lazy where

import PrettyPrint.Tables.LrcPrelude

--
--      Abstract Syntax
--
--
data R
	= C_RootR_1 !Table 
	deriving (Show , Eq , Ord)

data Table
	= C_RootTable_1 !LstAttribs !Rows 
	deriving (Show , Eq , Ord)

type LstAttribs = [Attrib]

data Attrib
	= C_Align_1 !STR 
	| C_AttBackground_1 !STR 
	| C_AttForeground_1 !STR 
	| C_AttrAny_1 !STR !STR 
	| C_AttrFont_1 !STR !INT 
	deriving (Show , Eq , Ord)

type Rows = [Row]

data Row
	= C_OneRow_1 !Elems 
	deriving (Show , Eq , Ord)

type Elems = [Elem]

data Elem
	= C_NestedTable_1 !Table 
	| C_TableText_1 !LstAttribs !FText 
	deriving (Show , Eq , Ord)

data FText
	= C_CBold_1 !FText 
	| C_CBr_1 
	| C_CCenter_1 !FText 
	| C_CColor_1 !STR !FText 
	| C_CEnumerate_1 !Items 
	| C_CFigure_1 !STR !FText 
	| C_CHuge_1 !FText 
	| C_CHyperLink_1 !STR !FText 
	| C_CItalic_1 !FText 
	| C_CItemize_1 !Items 
	| C_CLabels_1 !STR 
	| C_CLarge_1 !FText 
	| C_CLiteral_1 !STR 
	| C_CPar_1 
	| C_CReference_1 !STR 
	| C_CSmall_1 !FText 
	| C_CSpace_1 
	| C_CTable_1 !Table 
	| C_CText_1 !STR 
	| C_LstFrags_1 !LstText 
	| C_NoText_1 
	deriving (Show , Eq , Ord)

type Items = [Item]

data Item
	= C_ConsItem_1 !FText 
	| C_NoItem_1 
	deriving (Show , Eq , Ord)

type LstText = [FText]

data R2
	= C_RootR2_1 !Table2 
	deriving (Show , Eq , Ord)

data Table2
	= C_RootTable2_1 !LstAttribs !INT !Rows2 
	deriving (Show , Eq , Ord)

type Rows2 = [Row2]

data Row2
	= C_OneRow2_1 !Elems2 
	deriving (Show , Eq , Ord)

type Elems2 = [Elem2]

data Elem2
	= C_OneStr2_1 !LstAttribs !FText 
	| C_OneTable2_1 !Table2 
	deriving (Show , Eq , Ord)


--
--      Type of Attributes
--
--
data Celula
	= C_OneCel_1 !INT !INT !INT !INT !INT !STR !LstAttribs 
	deriving (Show , Eq , Ord)

type Celulas = [Celula]

type Html = [HtmlEl]

data HtmlAttr
	= C_ConsHtmlAttr_1 !STR !STR 
	deriving (Show , Eq , Ord)

type HtmlAttrs = [HtmlAttr]

data HtmlEl
	= C_ConsHtmlTag_1 !STR !HtmlAttrs !Html !STR 
	| C_ConsHtmlText_1 !STR 
	deriving (Show , Eq , Ord)

type LIST = [INT]

type STR_LIST = [STR]

data Vrml
	= C_RootVrml_1 !Celulas 
	deriving (Show , Eq , Ord)

