
module PrettyPrint.Tables.Visfun_Lazy where

import PrettyPrint.Tables.Data_Lazy
import PrettyPrint.Tables.LrcPrelude

--
-- Lazy Circular Evaluator Functions
--

lrcEval = visit_R

visit_R (C_RootR_1 t_Table ) = (x_html , x_latex , x_lines , x_mh , x_n , x_newtable , x_vrml )
  where
      x_vrml = x_vrml_2
      x_newtable = t_newt
      x_n = x_n_1
      x_mh = x_mh_2
      x_lines = x_lines_2
      x_latex = x_latex_2
      x_html = x_html_2
      x_aw_2 = 0
      x_ah_2 = 0
      t_newt = (C_RootR2_1 x_newtable_1)
      (x_n_1 , x_newtable_1 ) = visit_Table t_Table
      (x_html_2 , x_latex_2 , x_lines_2 , x_mh_2 , x_mw_2 , x_vrml_2 , x_vrmlmw_2 ) = visit_R2 t_newt x_ah_2 x_aw_2

visit_Table (C_RootTable_1 t_LstAttribs t_Rows ) = (x_n , x_newtable )
  where
      x_newtable = (C_RootTable2_1 t_LstAttribs x_n x_newtable_2)
      x_n = (maxList x_ns_2)
      x_ane_2 = x_n
      x_att_1 = ""
      (x_html_1 , x_res_1 , x_resVal_1 ) = visit_LstAttribs t_LstAttribs x_att_1
      (x_newtable_2 , x_ns_2 ) = visit_Rows t_Rows x_ane_2

visit_LstAttribs ((:) t_Attrib t_LstAttribs_2 ) x_att = (x_html , x_res , x_resVal )
  where
      x_att_2 = x_att
      x_resVal = (if x_res_1 then x_resVal_1 else x_resVal_2)
      x_res = (if x_res_1 then x_res_1 else x_res_2)
      x_html = (x_html_1++x_html_2)
      x_att_1 = x_att
      (x_html_1 , x_res_1 , x_resVal_1 ) = visit_Attrib t_Attrib x_att_1
      (x_html_2 , x_res_2 , x_resVal_2 ) = visit_LstAttribs t_LstAttribs_2 x_att_2
visit_LstAttribs ([] ) x_att = (x_html , x_res , x_resVal )
  where
      x_resVal = ""
      x_res = False
      x_html = ([] )

visit_Attrib (C_Align_1 t_STR ) x_att = (x_html , x_res , x_resVal )
  where
      x_resVal = (if ((x_att=="align")||(x_att=="font")) then t_STR else "")
      x_res = (if ((x_att=="align")||(x_att=="font")) then True else False)
      x_html = ([] )
visit_Attrib (C_AttBackground_1 t_STR ) x_att = (x_html , x_res , x_resVal )
  where
      x_resVal = (if ((x_att=="align")||(x_att=="font")) then t_STR else "")
      x_res = (if ((x_att=="align")||(x_att=="font")) then True else False)
      x_html = ([] )
visit_Attrib (C_AttForeground_1 t_STR ) x_att = (x_html , x_res , x_resVal )
  where
      x_resVal = (if ((x_att=="align")||(x_att=="font")) then t_STR else "")
      x_res = (if ((x_att=="align")||(x_att=="font")) then True else False)
      x_html = ([] )
visit_Attrib (C_AttrAny_1 t_STR t_STR_2 ) x_att = (x_html , x_res , x_resVal )
  where
      x_resVal = (if x_res then t_STR_2 else "")
      x_res = (if (x_att==t_STR) then True else False)
      x_html = (if ((t_STR=="bgcolor")||(t_STR=="border")) then ((:) (attr t_STR t_STR_2) ([] )) else ([] ))
visit_Attrib (C_AttrFont_1 t_STR t_INT ) x_att = (x_html , x_res , x_resVal )
  where
      x_resVal = (if ((x_att=="align")||(x_att=="font")) then t_STR else "")
      x_res = (if ((x_att=="align")||(x_att=="font")) then True else False)
      x_html = ([] )

visit_Rows ((:) t_Row t_Rows_2 ) x_ane = (x_newtable , x_ns )
  where
      x_ane_2 = x_ane
      x_ns = ((:) x_n_1 x_ns_2)
      x_newtable = ((:) x_newtable_1 x_newtable_2)
      x_ane_1 = x_ane
      (x_n_1 , x_newtable_1 ) = visit_Row t_Row x_ane_1
      (x_newtable_2 , x_ns_2 ) = visit_Rows t_Rows_2 x_ane_2
visit_Rows ([] ) x_ane = (x_newtable , x_ns )
  where
      x_ns = ([] )
      x_newtable = ([] )

visit_Row (C_OneRow_1 t_Elems ) x_ane = (x_n , x_newtable )
  where
      x_newtable = (C_OneRow2_1 x_newtable_1)
      x_n = x_n_1
      x_ane_1 = x_ane
      (x_n_1 , x_newtable_1 ) = visit_Elems t_Elems x_ane_1

visit_Elems ((:) t_Elem t_Elems_2 ) x_ane = (x_n , x_newtable )
  where
      x_ane_2 = (x_ane-1)
      x_newtable = ((:) x_newtable_1 x_newtable_2)
      x_n = (1+x_n_2)
      (x_newtable_1 ) = visit_Elem t_Elem
      (x_n_2 , x_newtable_2 ) = visit_Elems t_Elems_2 x_ane_2
visit_Elems ([] ) x_ane = (x_n , x_newtable )
  where
      x_newtable = (add_elems x_ane)
      x_n = 0

visit_Elem (C_NestedTable_1 t_Table ) = (x_newtable )
  where
      x_newtable = (C_OneTable2_1 x_newtable_1)
      (x_n_1 , x_newtable_1 ) = visit_Table t_Table
visit_Elem (C_TableText_1 t_LstAttribs t_FText ) = (x_newtable )
  where
      x_att_1 = ""
      x_newtable = (C_OneStr2_1 t_LstAttribs t_FText)
      (x_html_1 , x_res_1 , x_resVal_1 ) = visit_LstAttribs t_LstAttribs x_att_1
      (x_html_2 , x_latex_2 , x_nftexts_2 , x_str_2 ) = visit_FText t_FText

visit_FText (C_CBold_1 t_FText_2 ) = (x_html , x_latex , x_nftexts , x_str )
  where
      x_str = x_str_1
      x_nftexts = 1
      x_latex = ((" \\textbf{"++x_latex_1)++"}")
      x_html = (bold x_html_1)
      (x_html_1 , x_latex_1 , x_nftexts_1 , x_str_1 ) = visit_FText t_FText_2
visit_FText (C_CBr_1 ) = (x_html , x_latex , x_nftexts , x_str )
  where
      x_str = ""
      x_nftexts = 1
      x_latex = "\\\\"
      x_html = (br )
visit_FText (C_CCenter_1 t_FText_2 ) = (x_html , x_latex , x_nftexts , x_str )
  where
      x_str = x_str_1
      x_nftexts = 1
      x_latex = (("\\begin{center}\012"++x_latex_1)++"\012\\end{center}\012")
      x_html = (center x_html_1)
      (x_html_1 , x_latex_1 , x_nftexts_1 , x_str_1 ) = visit_FText t_FText_2
visit_FText (C_CColor_1 t_STR t_FText_2 ) = (x_html , x_latex , x_nftexts , x_str )
  where
      x_str = x_str_2
      x_nftexts = 1
      x_latex = ((((" \\textcolor{"++t_STR)++"}{")++x_latex_2)++"}")
      x_html = (tagWithAttrs "font" ((:) (attr "color" t_STR) ([] )) x_html_2)
      (x_html_2 , x_latex_2 , x_nftexts_2 , x_str_2 ) = visit_FText t_FText_2
visit_FText (C_CEnumerate_1 t_Items ) = (x_html , x_latex , x_nftexts , x_str )
  where
      x_str = ""
      x_nftexts = 1
      x_latex = case t_Items of { ( [] ) -> "" ; ( (:) _ _ ) -> (("\\begin{enumerate}\012"++x_latex_1)++"\012\\end{enumerate}\012") }
      x_html = (tag "ul" x_html_1)
      (x_html_1 , x_latex_1 ) = visit_Items t_Items
visit_FText (C_CFigure_1 t_STR t_FText_2 ) = (x_html , x_latex , x_nftexts , x_str )
  where
      x_str = x_str_2
      x_nftexts = 1
      x_latex = x_latex_2
      x_html = (image t_STR x_html_2)
      (x_html_2 , x_latex_2 , x_nftexts_2 , x_str_2 ) = visit_FText t_FText_2
visit_FText (C_CHuge_1 t_FText_2 ) = (x_html , x_latex , x_nftexts , x_str )
  where
      x_str = x_str_1
      x_nftexts = 1
      x_latex = ((" {\\Huge "++x_latex_1)++"}")
      x_html = (tagWithAttrs "font" ((:) (attr "size" "+4") ([] )) x_html_1)
      (x_html_1 , x_latex_1 , x_nftexts_1 , x_str_1 ) = visit_FText t_FText_2
visit_FText (C_CHyperLink_1 t_STR t_FText_2 ) = (x_html , x_latex , x_nftexts , x_str )
  where
      x_str = x_str_2
      x_nftexts = 1
      x_latex = (((x_latex_2++"\\link{")++t_STR)++"}")
      x_html = (link t_STR x_html_2)
      (x_html_2 , x_latex_2 , x_nftexts_2 , x_str_2 ) = visit_FText t_FText_2
visit_FText (C_CItalic_1 t_FText_2 ) = (x_html , x_latex , x_nftexts , x_str )
  where
      x_str = x_str_1
      x_nftexts = 1
      x_latex = ((" \\textit{"++x_latex_1)++"}")
      x_html = (italic x_html_1)
      (x_html_1 , x_latex_1 , x_nftexts_1 , x_str_1 ) = visit_FText t_FText_2
visit_FText (C_CItemize_1 t_Items ) = (x_html , x_latex , x_nftexts , x_str )
  where
      x_str = ""
      x_nftexts = 1
      x_latex = case t_Items of { ( [] ) -> "" ; ( (:) _ _ ) -> (("\\begin{itemize}\012"++x_latex_1)++"\012\\end{itemize}\012") }
      x_html = (tag "ul" x_html_1)
      (x_html_1 , x_latex_1 ) = visit_Items t_Items
visit_FText (C_CLabels_1 t_STR ) = (x_html , x_latex , x_nftexts , x_str )
  where
      x_str = t_STR
      x_nftexts = 1
      x_latex = ((" \\label{"++t_STR)++"}")
      x_html = (text t_STR)
visit_FText (C_CLarge_1 t_FText_2 ) = (x_html , x_latex , x_nftexts , x_str )
  where
      x_str = x_str_1
      x_nftexts = 1
      x_latex = ((" {\\Large "++x_latex_1)++"}")
      x_html = (tagWithAttrs "font" ((:) (attr "size" "+2") ([] )) x_html_1)
      (x_html_1 , x_latex_1 , x_nftexts_1 , x_str_1 ) = visit_FText t_FText_2
visit_FText (C_CLiteral_1 t_STR ) = (x_html , x_latex , x_nftexts , x_str )
  where
      x_str = t_STR
      x_nftexts = 1
      x_latex = ((" \\begin{verbatim}\012"++t_STR)++"\012\\end{verbatim}\012")
      x_html = (tag "pre" (text t_STR))
visit_FText (C_CPar_1 ) = (x_html , x_latex , x_nftexts , x_str )
  where
      x_str = ""
      x_nftexts = 1
      x_latex = "\012\012"
      x_html = (par ([] ))
visit_FText (C_CReference_1 t_STR ) = (x_html , x_latex , x_nftexts , x_str )
  where
      x_str = t_STR
      x_nftexts = 1
      x_latex = ((" \\ref{"++t_STR)++"}")
      x_html = (link ("#"++t_STR) (text t_STR))
visit_FText (C_CSmall_1 t_FText_2 ) = (x_html , x_latex , x_nftexts , x_str )
  where
      x_str = x_str_1
      x_nftexts = 1
      x_latex = ((" {\\small "++x_latex_1)++"}")
      x_html = (tagWithAttrs "font" ((:) (attr "size" "-2") ([] )) x_html_1)
      (x_html_1 , x_latex_1 , x_nftexts_1 , x_str_1 ) = visit_FText t_FText_2
visit_FText (C_CSpace_1 ) = (x_html , x_latex , x_nftexts , x_str )
  where
      x_str = ""
      x_nftexts = 1
      x_latex = " "
      x_html = (space )
visit_FText (C_CTable_1 t_Table ) = (x_html , x_latex , x_nftexts , x_str )
  where
      x_str = ""
      x_nftexts = 1
      x_latex = x_latex_2
      x_html = x_html_2
      t_tableTree = (C_RootR_1 t_Table)
      (x_n_1 , x_newtable_1 ) = visit_Table t_Table
      (x_html_2 , x_latex_2 , x_lines_2 , x_mh_2 , x_n_2 , x_newtable_2 , x_vrml_2 ) = visit_R t_tableTree
visit_FText (C_CText_1 t_STR ) = (x_html , x_latex , x_nftexts , x_str )
  where
      x_str = t_STR
      x_nftexts = 1
      x_latex = t_STR
      x_html = (text t_STR)
visit_FText (C_LstFrags_1 t_LstText ) = (x_html , x_latex , x_nftexts , x_str )
  where
      x_str = x_str_1
      x_nftexts = x_nftexts_1
      x_latex = x_latex_1
      x_html = x_html_1
      (x_html_1 , x_latex_1 , x_nftexts_1 , x_str_1 ) = visit_LstText t_LstText
visit_FText (C_NoText_1 ) = (x_html , x_latex , x_nftexts , x_str )
  where
      x_str = ""
      x_nftexts = 0
      x_latex = ""
      x_html = ([] )

visit_Items ((:) t_Item t_Items_2 ) = (x_html , x_latex )
  where
      x_latex = ((("\\item "++x_latex_1)++"\012")++x_latex_2)
      x_html = (x_html_1++x_html_2)
      (x_html_1 , x_latex_1 ) = visit_Item t_Item
      (x_html_2 , x_latex_2 ) = visit_Items t_Items_2
visit_Items ([] ) = (x_html , x_latex )
  where
      x_latex = ""
      x_html = ([] )

visit_Item (C_ConsItem_1 t_FText ) = (x_html , x_latex )
  where
      x_latex = x_latex_1
      x_html = (tag "li" x_html_1)
      (x_html_1 , x_latex_1 , x_nftexts_1 , x_str_1 ) = visit_FText t_FText
visit_Item (C_NoItem_1 ) = (x_html , x_latex )
  where
      x_latex = ""
      x_html = ([] )

visit_LstText ((:) t_FText t_LstText_2 ) = (x_html , x_latex , x_nftexts , x_str )
  where
      x_str = (x_str_1++x_str_2)
      x_nftexts = (1+x_nftexts_2)
      x_latex = (x_latex_1++x_latex_2)
      x_html = (x_html_1++x_html_2)
      (x_html_1 , x_latex_1 , x_nftexts_1 , x_str_1 ) = visit_FText t_FText
      (x_html_2 , x_latex_2 , x_nftexts_2 , x_str_2 ) = visit_LstText t_LstText_2
visit_LstText ([] ) = (x_html , x_latex , x_nftexts , x_str )
  where
      x_str = ""
      x_nftexts = 0
      x_latex = ""
      x_html = ([] )

visit_R2 (C_RootR2_1 t_Table2 ) x_ah x_aw = (x_html , x_latex , x_lines , x_mh , x_mw , x_vrml , x_vrmlmw )
  where
      x_y_1 = 0
      x_x_1 = 0
      x_vrmlaw_1 = 50
      x_level_1 = (if True then 0 else (g x_lines_1))
      x_aw_1 = x_aw
      x_attrs_1 = ([] )
      x_ah_1 = x_ah
      x_vrmlmw = x_vrmlmw_1
      x_vrml = (C_RootVrml_1 x_vrml_1)
      x_mw = x_mw_1
      x_mh = x_mh_1
      x_lines = x_lines_1
      x_latex = x_latex_1
      x_html = x_html_1
      (x_a_1 , x_html_1 , x_latex_1 , x_lines_1 , x_mh_1 , x_mw_1 , x_vrml_1 , x_vrmlmh_1 , x_vrmlmw_1 ) = visit_Table2 t_Table2 x_ah_1 x_attrs_1 x_aw_1 x_level_1 x_vrmlaw_1 x_x_1 x_y_1

visit_Table2 (C_RootTable2_1 t_LstAttribs t_INT t_Rows2 ) x_ah x_attrs x_aw x_level x_vrmlaw x_x x_y = (x_a , x_html , x_latex , x_lines , x_mh , x_mw , x_vrml , x_vrmlmh , x_vrmlmw )
  where
      x_vrmlmw = x_vrmllmw
      x_vrmlmh = x_vrmlmh_3
      x_vrml = x_vrml_3
      x_mw = x_lmw
      x_mh = x_mh_3
      x_lines = (if x_res_4 then (((add_sepline x_lmw)++x_lines_3)++(add_sepline x_lmw)) else x_lines_3)
      x_latex = (((("\\begin{tabular}{ "++x_eee)++" }\012\\hline \012")++x_latex_3)++"\\hline \012\\end{tabular}")
      x_html = (tagWithAttrs "table" x_html_1 x_html_3)
      x_a = t_LstAttribs
      x_upw_Table2_mw_3 = x_lmw
      x_y_3 = x_y
      x_x_3 = x_x
      x_vrmlaws_3 = x_vrmlmws_3
--      x_lines_3 = eq_RootTable2_4_lines(x_vrmlmh_3)
      x_level_3 = x_level
      x_border_3 = x_res_4
      x_aws_3 = x_mws_3
      x_attrs_3 = (t_LstAttribs++x_attrs)
      x_att_1 = ""
      x_att_4 = "border"
      x_vrmllmw = (sumList x_vrmlmws_3)
      x_lmw = (if x_res_4 then (((sumList x_mws_3)+(lengthList x_mws_3))-1) else (sumList x_mws_3))
      x_eee = ((repeatSTR "|l" t_INT)++"|")
      x_border = x_res_4
      t_lookupAttrs = t_LstAttribs
      (x_html_1 , x_res_1 , x_resVal_1 ) = visit_LstAttribs t_LstAttribs x_att_1
      (x_html_3 , x_latex_3 , x_lines_3 , x_mh_3 , x_mws_3 , x_vrml_3 , x_vrmlmh_3 , x_vrmlmws_3 ) = visit_Rows2 t_Rows2 x_attrs_3 x_aws_3 x_border_3 x_level_3 x_vrmlaws_3 x_x_3 x_y_3 x_upw_Table2_mw_3
      (x_html_4 , x_res_4 , x_resVal_4 ) = visit_LstAttribs t_lookupAttrs x_att_4

visit_Rows2 ((:) t_Row2 t_Rows2_2 ) x_attrs x_aws x_border x_level x_vrmlaws x_x x_y x_upw_Table2_mw = (x_html , x_latex , x_lines , x_mh , x_mws , x_vrml , x_vrmlmh , x_vrmlmws )
  where
      x_upw_Table2_mw_2 = x_upw_Table2_mw
      x_y_2 = (x_y+x_vrmlmh_1)
      x_x_2 = x_x
      x_vrmlaws_2 = x_vrmlaws
      x_level_2 = x_level
      x_border_2 = x_border
      x_aws_2 = x_aws
      x_attrs_2 = x_attrs
      x_vrmlmws = (eq_zipwith_max x_vrmlmws_1 x_vrmlmws_2)
      x_vrmlmh = (x_vrmlmh_1+x_vrmlmh_2)
      x_vrml = (x_vrml_1++x_vrml_2)
      x_mws = (eq_zipwith_max x_mws_1 x_mws_2)
      x_mh = (if x_border then ((x_mh_1+1)+x_mh_2) else (x_mh_1+x_mh_2))
      x_lines = (if x_border then (add_sep_line x_lmw x_lines_1 x_lines_2) else (x_lines_1++x_lines_2))
      x_latex = ((x_latex_1++"\\\\ \012\\hline\012")++x_latex_2)
      x_html = (x_html_1++x_html_2)
      x_upw_Table2_mw_1 = x_upw_Table2_mw
      x_y_1 = x_y
      x_x_1 = x_x
      x_vrmlaws_1 = x_vrmlaws
--      x_mws_1 = eq_ConsRow2_2_mws(x_border)
      x_level_1 = x_level
      x_border_1 = x_border
      x_aws_1 = x_aws
      x_attrs_1 = x_attrs
      x_lmw = (((sumList x_aws)+(lengthList x_aws))-1)
      (x_html_1 , x_latex_1 , x_lines_1 , x_mh_1 , x_mws_1 , x_vrml_1 , x_vrmlmh_1 , x_vrmlmws_1 ) = visit_Row2 t_Row2 x_attrs_1 x_aws_1 x_border_1 x_level_1 x_vrmlaws_1 x_x_1 x_y_1 x_upw_Table2_mw_1
      (x_html_2 , x_latex_2 , x_lines_2 , x_mh_2 , x_mws_2 , x_vrml_2 , x_vrmlmh_2 , x_vrmlmws_2 ) = visit_Rows2 t_Rows2_2 x_attrs_2 x_aws_2 x_border_2 x_level_2 x_vrmlaws_2 x_x_2 x_y_2 x_upw_Table2_mw_2
visit_Rows2 ([] ) x_attrs x_aws x_border x_level x_vrmlaws x_x x_y x_upw_Table2_mw = (x_html , x_latex , x_lines , x_mh , x_mws , x_vrml , x_vrmlmh , x_vrmlmws )
  where
      x_vrmlmws = (eq_zeros )
      x_vrmlmh = 0
      x_vrml = ([] )
      x_mws = (eq_zeros )
      x_mh = 0
      x_lines = ([] )
      x_latex = ""
      x_html = ([] )

visit_Row2 (C_OneRow2_1 t_Elems2 ) x_attrs x_aws x_border x_level x_vrmlaws x_x x_y x_upw_Table2_mw = (x_html , x_latex , x_lines , x_mh , x_mws , x_vrml , x_vrmlmh , x_vrmlmws )
  where
      x_vrmlmws = x_vrmlmws_1
      x_vrmlmh = x_vrmlmh_1
      x_vrml = x_vrml_1
      x_mws = x_mws_1
      x_mh = x_mh_1
      x_lines = (if x_border then (add_border_line x_lines_1) else (add_noborder_line x_lines_1))
      x_latex = x_latex_1
      x_html = (row x_html_1)
      x_upw_Table2_mw_1 = x_upw_Table2_mw
      x_y_1 = x_y
      x_x_1 = x_x
      x_vrmlaws_1 = x_vrmlaws
      x_vrmlah_1 = x_vrmlmh_1
--      x_mws_1 = eq_OneRow2_2_mws(x_attrs)
      x_level_1 = x_level
      x_border_1 = x_border
      x_aws_1 = x_aws
      x_attrs_1 = x_attrs
      x_ah_1 = x_mh_1
      (x_html_1 , x_latex_1 , x_lines_1 , x_mh_1 , x_mws_1 , x_vrml_1 , x_vrmlmh_1 , x_vrmlmws_1 , x_xo_1 ) = visit_Elems2 t_Elems2 x_ah_1 x_attrs_1 x_aws_1 x_border_1 x_level_1 x_vrmlah_1 x_vrmlaws_1 x_x_1 x_y_1 x_upw_Table2_mw_1

visit_Elems2 ((:) t_Elem2 t_Elems2_2 ) x_ah x_attrs x_aws x_border x_level x_vrmlah x_vrmlaws x_x x_y x_upw_Table2_mw = (x_html , x_latex , x_lines , x_mh , x_mws , x_vrml , x_vrmlmh , x_vrmlmws , x_xo )
  where
      x_upw_Table2_mw_2 = x_upw_Table2_mw
      x_y_2 = x_y
      x_x_2 = x_xo_1
      x_vrmlaws_2 = (tailList x_vrmlaws)
      x_vrmlah_2 = x_vrmlah
      x_level_2 = x_level
      x_border_2 = x_border
      x_aws_2 = (tailList x_aws)
      x_attrs_2 = x_attrs
      x_ah_2 = x_ah
      x_xo = x_xo_2
      x_vrmlmws = ((:) x_vrmlmw_1 x_vrmlmws_2)
      x_vrmlmh = (max x_vrmlmh_1 x_vrmlmh_2)
      x_vrml = (x_vrml_1++x_vrml_2)
      x_mws = ((:) x_mw_1 x_mws_2)
      x_mh = (max x_mh_1 x_mh_2)
      x_lines = (eq_zipwith_cat (addglue x_aw_1 x_mw_1 x_ah x_mh_1 x_lines_1 x_resVal_3) x_lines_2 x_border)
      x_latex = case t_Elems2_2 of { ( [] ) -> (x_latex_1++x_latex_2) ; _ -> ((x_latex_1++" & ")++x_latex_2) }
      x_html = (x_html_1++x_html_2)
      x_upw_Table2_mw_1 = x_upw_Table2_mw
      x_y_1 = x_y
      x_x_1 = x_x
      x_vrmlaw_1 = (headList x_vrmlaws)
      x_vrmlah_1 = x_vrmlah
      x_level_1 = x_level
      x_border_1 = x_border
      x_aw_1 = (headList x_aws)
      x_attrs_1 = x_attrs
      x_ah_1 = x_ah
      x_att_3 = "align"
      x_align = x_resVal_3
      t_lookupAttrs = x_a_1
      (x_a_1 , x_html_1 , x_latex_1 , x_lines_1 , x_mh_1 , x_mw_1 , x_vrml_1 , x_vrmlmh_1 , x_vrmlmw_1 , x_xo_1 ) = visit_Elem2 t_Elem2 x_ah_1 x_attrs_1 x_aw_1 x_border_1 x_level_1 x_vrmlah_1 x_vrmlaw_1 x_x_1 x_y_1 x_upw_Table2_mw_1
      (x_html_2 , x_latex_2 , x_lines_2 , x_mh_2 , x_mws_2 , x_vrml_2 , x_vrmlmh_2 , x_vrmlmws_2 , x_xo_2 ) = visit_Elems2 t_Elems2_2 x_ah_2 x_attrs_2 x_aws_2 x_border_2 x_level_2 x_vrmlah_2 x_vrmlaws_2 x_x_2 x_y_2 x_upw_Table2_mw_2
      (x_html_3 , x_res_3 , x_resVal_3 ) = visit_LstAttribs t_lookupAttrs x_att_3
visit_Elems2 ([] ) x_ah x_attrs x_aws x_border x_level x_vrmlah x_vrmlaws x_x x_y x_upw_Table2_mw = (x_html , x_latex , x_lines , x_mh , x_mws , x_vrml , x_vrmlmh , x_vrmlmws , x_xo )
  where
      x_xo = x_x
      x_vrmlmws = ([] )
      x_vrmlmh = 0
      x_vrml = ([] )
      x_mws = ([] )
      x_mh = 0
      x_lines = ([] )
      x_latex = ""
      x_html = ([] )

visit_Elem2 (C_OneStr2_1 t_LstAttribs t_FText ) x_ah x_attrs x_aw x_border x_level x_vrmlah x_vrmlaw x_x x_y x_upw_Table2_mw = (x_a , x_html , x_latex , x_lines , x_mh , x_mw , x_vrml , x_vrmlmh , x_vrmlmw , x_xo )
  where
      x_att_1 = ""
      x_xo = (x_x+x_vrmlaw)
      x_vrmlmw = (length x_str_2)
      x_vrmlmh = 1
      x_vrml = ((:) (C_OneCel_1 x_x x_y x_level x_vrmlaw x_vrmlah x_str_2 t_LstAttribs) ([] ))
      x_mw = (length x_str_2)
      x_mh = 1
      x_lines = ((:) x_str_2 ([] ))
      x_latex = (if (x_nftexts_2<=2) then x_latex_2 else case t_FText of { (C_LstFrags_1 lt) -> (((("\\begin{minipage}[t]{"++(lrc_REALtoSTR x_widthPerc))++"\\textwidth}\012")++x_latex_2)++"\012\\end{minipage}") ; _ -> x_latex_2 } )
      x_html = (elemHtml x_html_2)
      x_a = x_global_attrs
      x_widthPerc = ((lrc_INTtoREAL x_aw)/(lrc_INTtoREAL x_upw_Table2_mw))
      x_global_attrs = (t_LstAttribs++x_attrs)
      (x_html_1 , x_res_1 , x_resVal_1 ) = visit_LstAttribs t_LstAttribs x_att_1
      (x_html_2 , x_latex_2 , x_nftexts_2 , x_str_2 ) = visit_FText t_FText
visit_Elem2 (C_OneTable2_1 t_Table2 ) x_ah x_attrs x_aw x_border x_level x_vrmlah x_vrmlaw x_x x_y x_upw_Table2_mw = (x_a , x_html , x_latex , x_lines , x_mh , x_mw , x_vrml , x_vrmlmh , x_vrmlmw , x_xo )
  where
      x_y_1 = x_y
      x_x_1 = x_x
      x_vrmlaw_1 = x_vrmlaw
      x_level_1 = (x_level+1)
      x_aw_1 = x_aw
      x_attrs_1 = x_attrs
      x_ah_1 = x_ah
      x_xo = (x_x+x_vrmlaw)
      x_vrmlmw = x_vrmlmw_1
      x_vrmlmh = x_vrmlmh_1
      x_vrml = ((:) (C_OneCel_1 x_x x_y x_level x_vrmlaw x_vrmlah "" ([] )) x_vrml_1)
      x_mw = (if x_border then (x_mw_1+2) else x_mw_1)
      x_mh = (if x_border then (x_mh_1+1) else x_mh_1)
      x_lines = x_lines_1
      x_latex = x_latex_1
      x_html = (table x_html_1)
      x_a = x_a_1
      (x_a_1 , x_html_1 , x_latex_1 , x_lines_1 , x_mh_1 , x_mw_1 , x_vrml_1 , x_vrmlmh_1 , x_vrmlmw_1 ) = visit_Table2 t_Table2 x_ah_1 x_attrs_1 x_aw_1 x_level_1 x_vrmlaw_1 x_x_1 x_y_1

acenter =
 (attr "align" "center")



add_border_line l =
 case l of { ( [] ) -> ([] ) ; ( (:) s ls ) -> ((:) (("|"++s)++"|") (add_border_line ls)) }



add_elems n =
 (if (n<=0) then ([] ) else ((:) (C_OneStr2_1 ([] ) (C_CText_1 " ")) (add_elems (n-1))))





add_hor l aw a =
 case a of { "left" -> (l++(hor_spaces aw)) ; "right" -> ((hor_spaces aw)++l) ; "center" -> let { (y) = (lrc_REALtoINT (aw `div` 2)) } in (((hor_spaces y)++l)++(hor_spaces y)) ; _ -> (l++(hor_spaces aw)) }



add_noborder_line l =
 case l of { ( [] ) -> ([] ) ; ( (:) s ls ) -> ((:) s (add_noborder_line ls)) }



add_sep_line mw l rest =
 case rest of { ( [] ) -> (l++rest) ; ( (:) _ _ ) -> ((l++(add_sepline mw))++rest) }



add_sepline aw =
 (if (aw<=0) then ([] ) else ((:) (("|"++(repeatCHAR '-' aw))++"|") ([] )))



add_vertical aw =
 (if (aw<=0) then ([] ) else ((:) (repeatCHAR ' ' aw) ([] )))



addglue aw mw ah mh lines a =
 ((glue_horizontal aw mw lines a)++(glue_vertical_new (ah-mh) (add_vertical aw)))



aleft =
 (attr "align" "left")



aright =
 (attr "align" "right")



attr n v =
 (C_ConsHtmlAttr_1 n v)



bold h =
 (tag "b" h)



br =
 ((text " ")++(tag "br" ([] )))



center h =
 (tag "center" h)



elemHtml h =
 (tag "td" h)



elemWithAttrs attrs h =
 (tagWithAttrs "td" attrs h)



emph h =
 (tag "em" h)



eq_zeros =
 []



eq_zipwith_cat l1 l2 border =
 case l1 of { ( [] ) -> l2 ; ( (:) l11 l11s ) -> case l2 of { ( [] ) -> l1 ; ( (:) l22 l22s ) -> ((:) ((l11++(if border then "|" else "") )++l22) (eq_zipwith_cat l11s l22s border)) } }



eq_zipwith_max l1 l2 =
 case l1 of { ( [] ) -> l2 ; ( (:) l11 l11s ) -> case l2 of { ( [] ) -> l1 ; ( (:) l22 l22s ) -> ((:) (max l11 l22) (eq_zipwith_max l11s l22s)) } }



font h =
 (tag "font" h)



g x =
 0



glue_horizontal aw mw lines a =
 case lines of { ( [] ) -> ([] ) ; ( (:) l ls ) -> ((:) (add_hor l (aw-mw) a) (glue_horizontal aw mw ls a)) }



glue_vertical_new n l =
 (if (n<=0) then ([] ) else (l++(glue_vertical_new (n-1) l)))



headList l =
 case l of { ( [] ) -> 0 ; ( (:) l ls ) -> l }



hline =
 (tag "hr" ([] ))



hor_spaces aw =
 (if (aw<=0) then "" else (repeatCHAR ' ' aw))



image url h =
 (tagWithAttrs "img" ((:) (attr "src" url) ([] )) h)



italic h =
 (tag "i" h)



item h =
 (tag "li" h)



itemize h =
 (tag "ul" h)



lengthList l =
 case l of { ( [] ) -> 0 ; ( (:) h t ) -> (1+(lengthList t)) }



link url h =
 (tagWithAttrs "a" ((:) (attr "href" url) ([] )) h)



maxList l =
 case l of { ( [] ) -> 0 ; ( (:) l1 ls ) -> (max l1 (maxList ls)) }



par h =
 (tag "p" h)



repeatSTR s i =
 (if (i<=1) then s else (s++(repeatSTR s (i-1))))



row h =
 (tag "tr" h)



rowWithAttrs attrs h =
 (tagWithAttrs "tr" attrs h)



space =
 (text " ")



sumList l =
 case l of { ( [] ) -> 0 ; ( (:) h t ) -> (h+(sumList t)) }



table h =
 (tag "table" h)



tag s h =
 ((:) (C_ConsHtmlTag_1 s ([] ) h s) ([] ))



tagWithAttrs s attrs h =
 ((:) (C_ConsHtmlTag_1 s attrs h s) ([] ))



tailList l =
 case l of { ( [] ) -> ([] ) ; ( (:) l ls ) -> ls }



text s =
 ((:) (C_ConsHtmlText_1 s) ([] ))
