module PrettyPrint.XML.Xml2Dot where

import PrettyPrint.XML.Dot
import PrettyPrint.XML.LrcPrelude
import qualified Text.XML.HaXml.Types


--
-- Lazy Circular Evaluator Functions 
--

lrcEval = visit_Document

visit_Document (C_CDocument_1 t_Prolog t_Element t_Miscs )  = (x_dot ) 
  where
      x_indh_2 = 0
      x_dot = (C_CDot_1 (C_CBodyDiGraph_1 (C_CId_1 "XmlDOT") ((x_stmts_1++((:) (C_CStmtEdge_1 (C_CEdgeStmtNode_1 (C_CNodeId_1 (C_CId_1 "DeclXML")) ((:) (C_CRHSExpSubG_1 (C_CEdgeOp_1 "->") (C_CSubGId_1 (C_CId_1 "node0"))) ([] )) ([] ))) ([] )))++x_stmts_2)))
      (x_stmts_1 )   = visit_Prolog t_Prolog 
      (x_ind_2 , x_stmts_2 )   = visit_Element t_Element x_indh_2 

visit_Prolog (C_CProlog_1 t_XMLDecl t_Miscs )  = (x_stmts ) 
  where
      x_stmts = let  { (nodeProlog) = (recordAttr "DeclXML" x_attr_1)  } in ((:) nodeProlog ([] ))
      (x_attr_1 )   = visit_XMLDecl t_XMLDecl 

visit_XMLDecl (C_CXmlDecl_1 t_VersionInfo t_EncodingDecl t_SDDecl )  = (x_attr ) 
  where
      x_attr = (attrLabel ((("\\<?xml | "++x_str_1)++x_str_2)++" | ?\\>"))
      (x_str_1 )   = visit_VersionInfo t_VersionInfo 
      (x_str_2 )   = visit_EncodingDecl t_EncodingDecl 
visit_XMLDecl (C_NoXmlDecl_1 )  = (x_attr ) 
  where
      x_attr = (attrLabel "")

visit_VersionInfo (C_CVerInfo_1 t_Name )  = (x_str ) 
  where
      x_str = let  { (s) = (nameToSTR t_Name) ; (ns) = (lrc_string_sub s 2 ((length s)-1))  } in ((" { version |\\\""++ns)++"\\\" } ")
visit_VersionInfo (C_NoVerInfo_1 )  = (x_str ) 
  where
      x_str = ""

visit_Name (C_Ident_1 t_STR )  = () 

visit_EncodingDecl (C_CEncodingDecl_1 t_STR )  = (x_str ) 
  where
      x_str = let  { (ns) = (lrc_string_sub t_STR 2 ((length t_STR)-1))  } in (("| { encoding |\\\""++ns)++"\\\" } ")
visit_EncodingDecl (C_NoEncodingDecl_1 )  = (x_str ) 
  where
      x_str = ""

visit_SDDecl (C_CSDDecl_1 t_BOOL )  = () 
visit_SDDecl (C_NoSDDecl_1 )  = () 

visit_Miscs (C_LstMisc_1 t_Misc t_Miscs_2 )  = () 
visit_Miscs (C_NoMisc_1 )  = () 

visit_Misc (C_CPI_1 t_STR )  = () 
visit_Misc (C_Comment_1 t_Name )  = () 

visit_Element (C_CElement_1 t_Name t_LstAttribute t_LstContent t_Name_2 ) x_indh  = (x_ind , x_stmts ) 
  where
      x_origem_3 = x_indh
      x_indh_3 = (x_indh+1)
      x_stmts = ((:) x_node x_stmts_3)
      x_ind = x_ind_3
      x_node = let  { (tag) = (nameToSTR t_Name) ; (nodeid) = ("node"++(lrc_INTtoSTR x_indh))  } in let  { (btag) = (mk_btag tag) ; (etag) = (mk_etag tag)  } in (record nodeid (((btag++x_str_2)++"|  <port>  | ")++etag))
      (x_str_2 )   = visit_LstAttribute t_LstAttribute 
      (x_ind_3 , x_stmts_3 )   = visit_LstContent t_LstContent x_indh_3 x_origem_3 
visit_Element (C_CElementError_1 t_Name t_LstAttribute t_LstContent t_Name_2 ) x_indh  = (x_ind , x_stmts ) 
  where
      x_origem_3 = x_indh
      x_indh_3 = (x_indh+1)
      x_stmts = ((:) x_node x_stmts_3)
      x_ind = x_ind_3
      x_node = let  { (tag) = (nameToSTR t_Name) ; (nodeid) = ("node"++(lrc_INTtoSTR x_indh))  } in let  { (btag) = (mk_btag tag) ; (etag) = (mk_etag tag)  } in (recordError nodeid (((btag++x_str_2)++"|  <port>  | ")++etag))
      (x_str_2 )   = visit_LstAttribute t_LstAttribute 
      (x_ind_3 , x_stmts_3 )   = visit_LstContent t_LstContent x_indh_3 x_origem_3 
visit_Element (C_CEmptyElem_1 t_Name t_LstAttribute ) x_indh  = (x_ind , x_stmts ) 
  where
      x_stmts = ((:) x_node ([] ))
      x_ind = (x_indh+1)
      x_node = let  { (tag) = (nameToSTR t_Name) ; (nodeid) = ("node"++(lrc_INTtoSTR x_indh))  } in let  { (emtag) = (mk_emtag tag)  } in (record nodeid (emtag++x_str_2))
      (x_str_2 )   = visit_LstAttribute t_LstAttribute 
visit_Element (C_CSelectedElem_1 t_Name t_LstAttribute t_LstContent t_Name_2 ) x_indh  = (x_ind , x_stmts ) 
  where
      x_origem_3 = x_indh
      x_indh_3 = (x_indh+1)
      x_stmts = ((:) x_node x_stmts_3)
      x_ind = x_ind_3
      x_node = let  { (tag) = (nameToSTR t_Name) ; (nodeid) = ("node"++(lrc_INTtoSTR x_indh))  } in let  { (btag) = (mk_btag tag) ; (etag) = (mk_etag tag)  } in (recordSelected nodeid (((btag++x_str_2)++"|  <port>  | ")++etag))
      (x_str_2 )   = visit_LstAttribute t_LstAttribute 
      (x_ind_3 , x_stmts_3 )   = visit_LstContent t_LstContent x_indh_3 x_origem_3 
visit_Element (C_NoElement_1 ) x_indh  = (x_ind , x_stmts ) 
  where
      x_stmts = ([] )
      x_ind = x_indh

visit_LstAttribute (C_CLstAttribute_1 t_Attribute t_LstAttribute_2 )  = (x_str ) 
  where
      x_str = (x_str_1++x_str_2)
      (x_str_1 )   = visit_Attribute t_Attribute 
      (x_str_2 )   = visit_LstAttribute t_LstAttribute_2 
visit_LstAttribute (C_NoLstAttribute_1 )  = (x_str ) 
  where
      x_str = " "

visit_Attribute (C_CAttribute_1 t_Name t_AttValue )  = (x_str ) 
  where
      x_str = (((("| { "++(nameToSTR t_Name))++" | ")++x_value)++" } ")
      x_value = case t_AttValue of { (C_CAttValueString_1 s) -> (mk_quoted s) ; _ -> "" }

visit_AttValue (C_CAttValueRef_1 t_Reference )  = () 
visit_AttValue (C_CAttValueString_1 t_STR )  = () 

visit_Reference (C_CRefChar_1 t_STR )  = () 
visit_Reference (C_CRefEntity_1 t_STR )  = () 

visit_LstContent ((:) t_Content t_LstContent_2 ) x_indh x_origem  = (x_ind , x_stmts ) 
  where
      x_origem_2 = x_origem
      x_indh_2 = (x_ind_1+1)
      x_stmts = (x_stmts_1++x_stmts_2)
      x_ind = x_ind_2
      x_origem_1 = x_origem
      x_indh_1 = x_indh
      (x_ind_1 , x_stmts_1 )   = visit_Content t_Content x_indh_1 x_origem_1 
      (x_ind_2 , x_stmts_2 )   = visit_LstContent t_LstContent_2 x_indh_2 x_origem_2 
visit_LstContent ([] ) x_indh x_origem  = (x_ind , x_stmts ) 
  where
      x_stmts = ([] )
      x_ind = x_indh

visit_Content (C_CElem_1 t_Element ) x_indh x_origem  = (x_ind , x_stmts ) 
  where
      x_indh_1 = x_indh
      x_stmts = (x_stmts_1++(buildEdge x_origem x_indh))
      x_ind = x_ind_1
      (x_ind_1 , x_stmts_1 )   = visit_Element t_Element x_indh_1 
visit_Content (C_CMisc_1 t_Misc ) x_indh x_origem  = (x_ind , x_stmts ) 
  where
      x_stmts = ([] )
      x_ind = x_indh
visit_Content (C_CRef_1 t_Reference ) x_indh x_origem  = (x_ind , x_stmts ) 
  where
      x_stmts = ([] )
      x_ind = x_indh
visit_Content (C_CString_1 t_BOOL t_CharData ) x_indh x_origem  = (x_ind , x_stmts ) 
  where
      x_stmts = ((:) (leafRecord ("node"++(lrc_INTtoSTR x_indh)) x_str_2) (buildEdge x_origem x_indh))
      x_ind = x_indh
      (x_str_2 )   = visit_CharData t_CharData 

visit_CharData (C_CCharData_1 t_STR )  = (x_str ) 
  where
      x_str = t_STR

attrColor color  =
 (C_CAttr_1 (C_CId_1 "color") (C_CId_1 color))
 
 

attrFontcolor fontcolor  =
 (C_CAttr_1 (C_CId_1 "fontcolor") (C_CId_1 fontcolor))
 
 

attrFontname fontname  =
 (C_CAttr_1 (C_CId_1 "fontname") (C_CId_1 fontname))
 
 

attrFontsize fontsize  =
 (C_CAttr_1 (C_CId_1 "fontsize") (C_CId_1 fontsize))
 
 

attrHeight height  =
 (C_CAttr_1 (C_CId_1 "height") (C_CId_1 height))
 
 

attrLabel label  =
 (C_CAttr_1 (C_CId_1 "label") (C_CId_1 label))
 
 

attrShape shape  =
 (C_CAttr_1 (C_CId_1 "shape") (C_CId_1 shape))
 
 

attrStyle s  =
 (C_CAttr_1 (C_CId_1 "style") (C_CId_1 s))
 
 

buildEdge origem destino  =
 let  { (nodeidOri) = (C_CNodeIdPort_1 (C_CId_1 ("node"++(lrc_INTtoSTR origem))) (C_CId_1 "port")) ; (nodeidDes) = (mk_nameId destino) ; (edgeRHS) = ((:) (C_CRHSExpNode_1 (C_CEdgeOp_1 "->") nodeidDes) ([] )) ; (edge) = (C_CStmtEdge_1 (C_CEdgeStmtNode_1 nodeidOri edgeRHS ([] )))  } in ((:) edge ([] ))
 
 

leafRecord name conteudo  =
 (C_CStmtNode_1 (C_CNodeStmt_1 (C_CNodeId_1 (C_CId_1 name)) ((:) (attrShape "record") ((:) (attrHeight ".5") ((:) (attrFontcolor "white") ((:) (attrColor "black") ((:) (attrStyle "filled") ((:) (attrFontname "Courier") ((:) (attrFontsize "12") ((:) (attrLabel conteudo) ([] )))))))))))
 
 

mk_btag t  =
 (("\\<"++t)++"\\>")
 
 

mk_emtag t  =
 (("\\<"++t)++"/\\>")
 
 

mk_etag t  =
 (("\\</"++t)++"\\>")
 
 

mk_nameId n  =
 (C_CNodeId_1 (C_CId_1 ("node"++(lrc_INTtoSTR n))))
 
 

mk_quoted s  =
 (("\\\""++s)++"\\\"")
 
 

nameToSTR n  =
 case n of { (C_Ident_1 s) -> s } 
 
 

nodeBinRecord nodeID labelValue  =
 (C_CStmtNode_1 (C_CNodeStmt_1 (C_CNodeId_1 (C_CId_1 nodeID)) ((:) (attrShape "record") ((:) (attrHeight ".2") ((:) (attrLabel labelValue) ([] ))))))
 
 

nodeCircle nodeID labelValue  =
 (C_CStmtNode_1 (C_CNodeStmt_1 (C_CNodeId_1 (C_CId_1 nodeID)) ((:) (attrShape "circle") ((:) (attrLabel labelValue) ([] )))))
 
 

nodeRecord1 nodeFather nodeChild  =
 ((:) (C_CStmtNode_1 (C_CNodeStmt_1 (C_CNodeId_1 (C_CId_1 nodeFather)) ((:) (attrShape "record") ((:) (attrHeight ".2") ((:) (attrLabel " <c> ") ([] )))))) ((:) (C_CStmtEdge_1 (C_CEdgeStmtNode_1 (C_CNodeIdPort_1 (C_CId_1 nodeFather) (C_CId_1 "c")) ((:) (C_CRHSExpNode_1 (C_CEdgeOp_1 "->") (C_CNodeId_1 (C_CId_1 nodeChild))) ([] )) ([] ))) ([] )))
 
 

nodeRecord1WithValue value nodeFather nodeChild  =
 ((:) (C_CStmtNode_1 (C_CNodeStmt_1 (C_CNodeId_1 (C_CId_1 nodeFather)) ((:) (attrShape "record") ((:) (attrHeight ".2") ((:) (attrLabel (value++" | <c> ")) ([] )))))) ((:) (C_CStmtEdge_1 (C_CEdgeStmtNode_1 (C_CNodeIdPort_1 (C_CId_1 nodeFather) (C_CId_1 "c")) ((:) (C_CRHSExpNode_1 (C_CEdgeOp_1 "->") (C_CNodeId_1 (C_CId_1 nodeChild))) ([] )) ([] ))) ([] )))
 
 

nodeRecord2 nodeFather nodeLeft nodeRight  =
 ((:) (C_CStmtNode_1 (C_CNodeStmt_1 (C_CNodeId_1 (C_CId_1 nodeFather)) ((:) (attrShape "record") ((:) (attrHeight ".2") ((:) (attrLabel " <c1> | <c2> ") ([] )))))) ((:) (C_CStmtEdge_1 (C_CEdgeStmtNode_1 (C_CNodeIdPort_1 (C_CId_1 nodeFather) (C_CId_1 "c1")) ((:) (C_CRHSExpNode_1 (C_CEdgeOp_1 "->") (C_CNodeId_1 (C_CId_1 nodeLeft))) ([] )) ([] ))) ((:) (C_CStmtEdge_1 (C_CEdgeStmtNode_1 (C_CNodeIdPort_1 (C_CId_1 nodeFather) (C_CId_1 "c2")) ((:) (C_CRHSExpNode_1 (C_CEdgeOp_1 "->") (C_CNodeId_1 (C_CId_1 nodeRight))) ([] )) ([] ))) ([] ))))
 
 

nodeRecord2WithValue value nodeFather nodeLeft nodeRight  =
 ((:) (C_CStmtNode_1 (C_CNodeStmt_1 (C_CNodeId_1 (C_CId_1 nodeFather)) ((:) (attrShape "record") ((:) (attrHeight ".2") ((:) (attrLabel (value++" | <c1> | <c2> ")) ([] )))))) ((:) (C_CStmtEdge_1 (C_CEdgeStmtNode_1 (C_CNodeIdPort_1 (C_CId_1 nodeFather) (C_CId_1 "c1")) ((:) (C_CRHSExpNode_1 (C_CEdgeOp_1 "->") (C_CNodeId_1 (C_CId_1 nodeLeft))) ([] )) ([] ))) ((:) (C_CStmtEdge_1 (C_CEdgeStmtNode_1 (C_CNodeIdPort_1 (C_CId_1 nodeFather) (C_CId_1 "c2")) ((:) (C_CRHSExpNode_1 (C_CEdgeOp_1 "->") (C_CNodeId_1 (C_CId_1 nodeRight))) ([] )) ([] ))) ([] ))))
 
 

nodeRecord3 nodeID  =
 (C_CStmtNode_1 (C_CNodeStmt_1 (C_CNodeId_1 (C_CId_1 nodeID)) ((:) (attrShape "record") ((:) (attrHeight ".2") ((:) (attrLabel " <c1> | <c2> | <c3> ") ([] ))))))
 
 

nodeRecordWithValue value nodeID  =
 (C_CStmtNode_1 (C_CNodeStmt_1 (C_CNodeId_1 (C_CId_1 nodeID)) ((:) (attrShape "record") ((:) (attrHeight ".2") ((:) (attrLabel value) ([] ))))))
 
 

record name label  =
 (recordAttr name (attrLabel label))
 
 

recordAttr name attrLabel  =
 (C_CStmtNode_1 (C_CNodeStmt_1 (C_CNodeId_1 (C_CId_1 name)) ((:) (attrShape "record") ((:) (attrHeight ".5") ((:) attrLabel ([] ))))))
 
 

recordError name conteudo  =
 (C_CStmtNode_1 (C_CNodeStmt_1 (C_CNodeId_1 (C_CId_1 name)) ((:) (attrShape "record") ((:) (attrHeight ".5") ((:) (attrFontcolor "black") ((:) (attrColor "red") ((:) (attrStyle "filled") ((:) (attrFontname "Courier") ((:) (attrFontsize "12") ((:) (attrLabel conteudo) ([] )))))))))))
 
 

recordSelected name conteudo  =
 (C_CStmtNode_1 (C_CNodeStmt_1 (C_CNodeId_1 (C_CId_1 name)) ((:) (attrShape "record") ((:) (attrHeight ".5") ((:) (attrFontcolor "white") ((:) (attrColor "blue") ((:) (attrStyle "filled") ((:) (attrFontname "Courier") ((:) (attrFontsize "12") ((:) (attrLabel conteudo) ([] )))))))))))



{- just 'casting' from HaXML Element to XML-Dot Element -}

castElement :: Text.XML.HaXml.Types.Element -> Element
castElement (Text.XML.HaXml.Types.Elem name [] lcontent) = C_CElement_1 (C_Ident_1 name) C_NoLstAttribute_1 (map castContent lcontent) (C_Ident_1 "x")


castContent :: Text.XML.HaXml.Types.Content -> Content
castContent (Text.XML.HaXml.Types.CElem elem)    = C_CElem_1 (castElement elem) 
castContent (Text.XML.HaXml.Types.CString b str) = C_CString_1 b (C_CCharData_1 str)
 

