module Main where

import Control.WashExtras
import CGI

page1 :: FileReference -> CGI ()
page1 fileRef = standardQuery "FileReference" (text (show fileRef))

page2 :: () -> CGI ()
page2 () = standardQuery "()" (text "No arguments")

page3 :: (Int,Integer) -> CGI ()
page3 (x,y) = standardQuery "Tuple" $ do
  p $ text (show x)
  p $ text (show y)

page4 :: [Int] -> CGI ()
page4 xs = standardQuery "List" (text (show xs))

page5 :: Int -> CGI ()
page5 s = standardQuery "Int" (text (show s))

page6 :: String -> CGI ()
page6 s = standardQuery "String" (text s)

page7 :: Bool -> CGI ()
page7 b = standardQuery "Bool" (text (show b))

page8 :: Int -> CGI ()
page8 n = standardQuery "Radio group" $ text (show n)

main = run mainCGI

mainCGI = standardQuery "Menu" $ simpleMenuFor menuButtons

menuButtons = [
  ("FileReference", mkInputPage' "File: " () page1),
  ("F0", mkInputPage' () () page2),
  ("F2", mkInputPage' ("Jut","Jul") (True,False) page3),
  ("Multiple", mkInputPage' "Multiple" [1,2,3::Int] page4),
  ("Single", mkInputPage' "Single" [1,2,3::Int] page5),
  ("Single (pre-select)", mkInputPage' "Single" (PreSelect 1 [1,2,3::Int]) page5),
  ("Text area", mkInputPage' "Text area" "<type here>" page6),
  ("Check box", mkInputPage' "Check?" () page7),
  ("Radio",mkInputPage' () (OneOf [1,2,3::Int]) page8)
 ]

mkInputPage' :: (ConnectCGI possibleValues labeling value handle,
                InputHandle handle)
            => labeling             -- ^ labeling information
            -> possibleValues       -- ^ description of possible values
            -> (value -> CGI ())    -- ^ parameterized page
            -> CGI ()               -- ^ input page
mkInputPage' = mkInputPage "Form" "Ok"

