module Test where

plus :: (Int, Int) -> Int
plus = uncurry (+)

fib :: Int -> Int
fib 0 = 1
fib 1 = 1
fib x = fib (x-1) + fib (x-2)

isort :: Ord a => [a] -> [a]
isort [] = []
isort (x:xs) = insert (x,(isort xs))

insert :: Ord a => (a,[a]) -> [a]
insert (x,[]) = [x]
insert (x,y:ys) | x<=y = x:y:ys
		| otherwise = y:(insert (x,ys))

fact 0 = 1
fact n = n * fact (n-1)

len [] = 0
len (x:xs) = 1+(len xs)

qsort :: (Ord a) => [a] -> [a]
qsort [] = []
qsort (x:xs) = qsort (filter (<=x) xs) ++ [x] ++ qsort (filter (>x) xs)

msort :: (Ord a) => [a] -> [a]
msort [] = []
msort [x] = [x]
msort l = let aux = msplit l
          in merge (msort (fst aux), msort (snd aux))

msplit :: [a] -> ([a],[a])
msplit [] = ([],[])
msplit (x:xs) = let aux = msplit xs
		in (x:snd aux, fst aux)

merge :: (Ord a) => ([a],[a]) -> [a]
merge ([],l) = l
merge (l,[]) = l
merge (x:xs,y:ys) | x<=y = x:merge (xs,y:ys)
		  | otherwise = y:merge (x:xs,ys)

hsort :: (Ord a) => [a] -> [a]
hsort [] = []
hsort l = let aux = hsplit l
	   in (fst aux):(merge (hsort (fst (snd aux)), hsort (snd (snd aux))))

hsplit :: (Ord a) => [a] -> (a,([a],[a]))
hsplit [x] = (x,([],[]))
hsplit (h:t) | h < m     = (h,(m:l,r))
	     | otherwise = (m,(h:r,l))
	     where (m,(l,r)) = hsplit t
